/*
 * File: app/controller/components/discovery/Container.js
 *
 * This file was generated by Sencha Architect
 * http://www.sencha.com/products/architect/
 *
 * This file requires use of the Ext JS 4.2.x library, under independent license.
 * License of Sencha Architect does not include license for Ext JS 4.2.x. For more
 * details see http://www.sencha.com/license or contact license@sencha.com.
 *
 * This file will be auto-generated each and everytime you save your project.
 *
 * Do NOT hand edit this file.
 */

Ext.define('Discovery.controller.components.discovery.Container', {
	extend: 'Ext.app.Controller',

	statics: {
		changeTo: function(selector, visibleFunction, getTitle) {
			var active = opmon.helpers.zip(function(tab, el, tabTitle, checkbox) {
				tab.setActiveTab(el);
				checkbox[visibleFunction || "hide"]();
				if (getTitle && typeof getTitle === "function") {
					tabTitle.setText(getTitle());
				}
				return [ tab, el ];
			});

			var tabs = Ext.ComponentQuery.query("#tabsView");

			var elements = Ext.ComponentQuery.query(selector);

			var tabTitle = Ext.ComponentQuery.query('#titleHeaderChange');

			var checkbox = Ext.ComponentQuery.query("#see_hosts_before");

			var reduced = active(tabs, elements, tabTitle, checkbox);

			return (reduced.length > 0);
		},

		getSomeExistingTag: function(xs) {
			var supportedIcons =
			[ 'opmon'
			, 'apple'
			, 'linux'
			, 'windows'
			, 'microsoft'
			, 'cisco'
			, '3com'
			, 'juniper'
			, 'd-link'
			, 'vmware'
			, 'apache'
			, 'mailserver'
			, 'mysql'
			, 'ssh'
			, 'samsung'
			, 'motorola'
			, 'asus'
			, 'hp'
			, 'freebsd'
			, 'xen'
			, 'android'
			, 'printer'
			, 'router'
			, 'switch'
			, 'amazon'
			, 'app'
			, 'database'
			, 'cloud'
			, 'customi'
			, 'html'
			, 'opcem'
			, 'trafficanalyser'
			, 'virtualization'
			, 'protocol'
			, 'key'
			, 'webserver'
			, 'postgresql'
			, 'openvpn'
			, 'oracle'
			, 'exchange'
			];

			return xs.reduce(
			function findIcon(acc, x) {
				return supportedIcons.some(opmon.helpers.equals(x))
				? x
				: acc;
			},
			"other"
			);
		},

		processHosts: function(xs) {
			var data = {
				hosts: this.getHosts(xs),
				from: "discovery"
			};

			Discovery.closeWindow = function(success) {
				Discovery.detailsWindow.destroy();
			};

			Discovery.data = data;
			WIZZARD_CONFIG_PARAMS = data;

			Discovery.detailsWindow = new Ext.Window({
				title : l["Configuring hosts"],
				id: 'global_config_window',
				width : parseInt(window.innerWidth*0.93),
				height: parseInt(window.innerHeight*0.9),
				layout : 'card',
				border: false,
				autoScroll: false,
				draggable: false,
				modal: true,
				resizable: false,
				items : [
				{
					xtype : "component",
					id: 'models',
					autoEl : {
						tag : "iframe",
						src : "/opmon/seagull/modules/models/templates/app.php"
					}
				},
				{
					xtype : "component",
					id: 'wizard',
					autoEl : {
						tag : "iframe",
					}
				}
				]
			});

			Discovery.detailsWindow.show();
		},

		getGridSelectionMode: function() {
			return Ext.ComponentQuery.query("#discoveryGrid #gridView")[0].getSelectionModel();
		},

		extractProps: function(hostRec) {
			return {
				"host_name": hostRec.get("host_name"),
				"address": hostRec.get("host_ip"),
				"tags": hostRec.get("discovered_tags")
			};
		},

		getHosts: function(xs) {
			return (Array.isArray(xs))
			? xs.map(this.extractProps)
			: this.getGridSelectionMode().getSelection().map(this.extractProps);
		},

		listHosts: function(xs) {
			Ext.ComponentQuery.query("#discoveryGrid #gridView").forEach(function(el) {
				this.changeTo("#tabsview-grid", "hide", this.totalDevicesTitle);
				el.getSelectionModel().select(xs);
				el.store.load();
				Discovery.app.getController("components.discovery.Grid").setStateScroll(0);
			}, this);
		},

		totalTagsTitle: function() {
			var total = Ext.getStore("TagsDiscoveryDB").getTotal();
			return (total + " " + Ext.locale.translate("devices and applications discovered"));
		},

		totalDevicesTitle: function() {
			var store = Ext.getStore("HostDiscoveryDB");
			return (store.count() + " " + Ext.locale.translate("devices discovered"));
		},

		updateTitle: function() {
			var fns = { "tabsview-board": this.totalTagsTitle, "tabsview-grid": this.totalDevicesTitle };

			var performChange = opmon.helpers.zip(function(view, titleEl) {
				var tab = view.getActiveTab();
				var f = fns[tab.itemId] || fns["tabsview-board"];
				var title = f();
				titleEl.setText(title);
				return [ title, tab ];
			});

			var tabView = Ext.ComponentQuery.query("#tabsView");

			var titleEl = Ext.ComponentQuery.query('#titleHeaderChange');

			return performChange(tabView, titleEl).length > 0;
		}
	},

	refs: [
		{
			ref: 'tabsView',
			selector: '#tabsView'
		}
	],

	onDataviewItemClick: function(dataview, record, item, index, e, eOpts) {
		var me = Discovery.controller.components.discovery.Container;

		var hosts = Ext.getStore("HostDiscoveryDB").data.items
			.filter(function(hostRec) {
				return hostRec.get("discovered_tags")
					.some(opmon.helpers.equals(record.get("id")));
			});

		var f = Ext.ComponentQuery.query("#see_hosts_before")
			.reduce(function(f, el) {
				return (!el.getValue()) ? f : me.listHosts.bind(me);
			}, me.processHosts.bind(me));

		f(hosts);
	},

	init: function(application) {
		this.control({
			"#tags_dataview": {
				itemclick: this.onDataviewItemClick
			}
		});
	}

});
