/*
 * File: app/controller/components/discovery/Job.js
 *
 * This file was generated by Sencha Architect
 * http://www.sencha.com/products/architect/
 *
 * This file requires use of the Ext JS 4.2.x library, under independent license.
 * License of Sencha Architect does not include license for Ext JS 4.2.x. For more
 * details see http://www.sencha.com/license or contact license@sencha.com.
 *
 * This file will be auto-generated each and everytime you save your project.
 *
 * Do NOT hand edit this file.
 */

Ext.define('Discovery.controller.components.discovery.Job', {
	extend: 'Ext.app.Controller',

	onDiscoveryRunningClick: function(button, e, eOpts) {
		Discovery.app.getController('components.settingstoolbar.RangeProcessPanel').createWindow().show();
	},

	requestAJob: function(address, callbackFn) {
		this.request(
			{
				params: {
					operation: "add",
					mask: typeof address === 'object' ? address.get('host_ip') : address
				}
			},
			Ext.locale.translate('New IP or added range'),
			callbackFn
		);
	},

	request: function(options, successMsg, callbackFn) {
		var errorMsgOptions = {title: Ext.locale.translate('Error'), icon: Ext.MessageBox.ERROR, closable: true};
		var successMsgOptions = {title: Ext.locale.translate('Success'), msg: successMsg, icon: Ext.MessageBox.INFO, closable: false};

		var defaultOptions = {
			method: "POST",
			url: "/opmon/seagull/www/index.php/discovery/action/discovery_jobs/",

			success: function(result, request) {
				var ret = JSON.parse(result.responseText);

				if (! ret) {
					return Ext.MessageBox.show(Ext.apply(errorMsgOptions, {msg: result.responseText}));
				}

				if (! ret.success) {
					return Ext.MessageBox.show(Ext.apply(errorMsgOptions, {msg: ret.message}));
				}

				Ext.MessageBox.show(successMsgOptions);
				setTimeout(Ext.MessageBox.hide.bind(Ext.MessageBox), 1000);

				return (typeof callbackFn === 'function') ? callbackFn.apply(null, arguments) : true;
			},

			failure: function(result, request) {
				Ext.MessageBox.show(Ext.apply(errorMsgOptions, {msg: result.responseText, closable: false}));
				setTimeout(Ext.MessageBox.hide.bind(Ext.MessageBox), 1000);

				return (typeof callbackFn === 'function') ? callbackFn.apply(null, arguments) : false;
			}
		};

		return Ext.Ajax.request(Ext.apply(defaultOptions, options));
	},

	removalRequest: function(hosts) {
		var me = this;

		Ext.Msg.confirm({
			buttons: Ext.MessageBox.OKCANCEL,
			title: Ext.locale.translate('Confirmation'),
			msg: Ext.locale.translate('Do you really want to apply all the changes ?'),
			fn: function(btn){
				if (btn !== 'ok') return false;

				me.request(
					{
						params: {
							operation: 'delete_objects',
							hostnames_to_delete: JSON.stringify(me.mapHostname(hosts))
						}
					},
					Ext.locale.translate('Operation succeeded'),
					function() {
						return me.getStore('HostDiscoveryDB').reload();
					}
				);
			}

		});
	},

	mapHostname: function(records) {
		return (records instanceof Array ? records : [records]).map(function(r) {
			return r.get('host_name');
		});
	},

	init: function(application) {
		this.control({
			"#discoveryRunningButton": {
				click: this.onDiscoveryRunningClick
			}
		});
	}

});
