/*
 * File: app/controller/components/settingstoolbar/SnmpWindow.js
 *
 * This file was generated by Sencha Architect
 * http://www.sencha.com/products/architect/
 *
 * This file requires use of the Ext JS 4.2.x library, under independent license.
 * License of Sencha Architect does not include license for Ext JS 4.2.x. For more
 * details see http://www.sencha.com/license or contact license@sencha.com.
 *
 * This file will be auto-generated each and everytime you save your project.
 *
 * Do NOT hand edit this file.
 */

Ext.define('Discovery.controller.components.settingstoolbar.SnmpWindow', {
	extend: 'Ext.app.Controller',

	onAddSnmpClick: function(button, e, eOpts) {
		this.activeForm();
	},

	onFormSnmpCancelClick: function(button, e, eOpts) {
		this.getFormCmp().getForm().reset();
		this.activeList();
	},

	onFormSnmpSaveClick: function(target) {
		if (! this.window.getComponent('form').isValid()) {
			return;
		}

		var snmpStore = this.getStore('SNMPCommunityDB');
		var formSnmp = this.getFormCmp();

		formSnmp.getForm().updateRecord();
		var record = formSnmp.getForm().getRecord();

		if (record.data.community_id === 0) {
			snmpStore.add(record);
			snmpStore.sync({
				success: function(){
					snmpStore.reload();
				}
			});


		} else {
			snmpStore.sync();
		}

		this.activeList();
	},

	onActionColClick: function(actioncolumn, el, rowIndx, colIndx, dom, record) {
		var operation = opmon.helpers.choseAction(
			opmon.helpers.actionIconReg(),
			dom,
			{
				editar: this.activeForm,
				excluir: opmon.helpers.confirmAction(
					Ext.locale.translate('Do you really want to remove it?'),
					this.removeRecord,
					this
				)
			},
			this // Context of the function call
		);

		operation(record);
	},

	createWindow: function() {
		this.window = Ext.create("Discovery.view.components.settingstoolbar.snmp.Tab", {
			items: [ Ext.create("Authentication.view.Main") ]
		});
		return this.window;
	},

	getFormCmp: function() {
		return this.window.getComponent('form');
	},

	activeForm: function(record) {
		var rec = record || Ext.create('Discovery.model.SNMPCommunity');

		this.changeWindowSize({width: 350});
		this.window.layout.setActiveItem('form');
		this.getFormCmp().getForm().loadRecord(rec);

	},

	activeList: function() {
		var bodyWidth = Ext.getBody().getViewSize().width;

		this.changeWindowSize({width: 600});
		this.window.layout.setActiveItem('list');
	},

	removeRecord: function(record) {
		var store = this.getStore('SNMPCommunityDB');

		store.remove(record);
		store.sync({
			failure: function(batch, options) {
				var response = batch.proxy.getReader().rawData;
				var message = response.message;
				var hosts = "";
				if (response.message.indexOf(':') > 0) {
					var tempArray = response.message.split(':');
					message = Ext.locale.translate(tempArray[0]);

					// This test is needed to guarantee that variable message is not undefined
					message = message || 'This authentication cannot be removed because is used by the following hosts';

					hosts = ": " + tempArray[1];
				}

				Ext.MessageBox.show({
					title: Ext.locale.translate('Request Status'),
					msg: message + hosts,
					icon: Ext.MessageBox.ERROR,
					closable: true
				});
				store.reload();
			}
		});
	},

	changeWindowSize: function(size) {
		this.window.setSize(size);
		this.window.center();
	},

	init: function(application) {
		this.control({
			"#addSnmp": {
				click: this.onAddSnmpClick
			},
			"#formSnmpCancel": {
				click: this.onFormSnmpCancelClick
			},
			"#formSnmpSave": {
				click: this.onFormSnmpSaveClick
			},
			"#tabSnmp #actionCol": {
				click: this.onActionColClick
			}
		});
	}

});
