// Instacie or Create Opmon object
var opmon = opmon || {};


// Get helpers
opmon.helpers =
	(function()
		{
			'use strict';
			
			// confirmAct :: String, Function, Object -> Function :: A -> B
			var confirmAct = function(tag, op, me) {
				return function(value) {
					return Ext.Msg.confirm('Confirm change', tag, function(res) {
						return res === 'yes' ? op.call(me, value) : false;
					});
				};
			};
			
			// matchClassName :: Object, Object -> Array
			var matchClassName = function(t, r) {
				return t.className.match(r);
			};
			
			// choseAct :: String, DOM, Object, Object -> Function
			var choseAct = function(reg, el, operations, context) {
				var target = matchClassName(el.target, reg) || [];
				var doestnExistMsg = console.log.bind(console, 'There isnt a controller function to this action');
				var fn = operations[target[1]] || doestnExistMsg;
				return fn.bind(context);
			};
			
			// actIconReg :: __ -> String
			var actIconReg = function() {
				return /.*ico-([^ ]+).*/;
			};
			
			var zip = function(f) {
				return function() {
					var xxs = Array.prototype.slice.call(arguments);
					return lowerArray(xxs)
						.map(function(_, i) {
							var args = xxs.map(function(xs) { return xs[i]; });
							return f.apply(null, args);
						});
				};
			};
			
			var lowerArray = function(xxs) {
				return xxs.reduce(function(lower, next) {
					return next.length < lower.length ? next : lower;
				});
			};
			
            var flat = function(xxs) {
                return xxs.reduce(function(acc, xs) {
                    return acc.concat(xs);
                }, []);
            };
			
			
			// captilize :: String -> Maybe String
			var captilize = function(str) {
				return OPSupport.Maybe.of(function(head) {
					return function(tail) {
						return head.toUpperCase().concat(tail);
					};
				})
				.ap(OPSupport.Maybe.of(str[0]))
				.ap(OPSupport.Maybe.of(str.slice(1)));
			};
			
			// equals :: (a, a) -> Bool
			var equals = function(x) {
				return function(y) {
					return x === y;
				};
			};

			// Module interface
			return {
				confirmAction: confirmAct,
				choseAction: choseAct,
				actionIconReg: actIconReg,
				zip: zip,
                flat: flat,
				captilize: captilize,
				equals: equals
			};
		}
	)();