/*
 * File: app/store/HostDiscoveryDB.js
 *
 * This file was generated by Sencha Architect
 * http://www.sencha.com/products/architect/
 *
 * This file requires use of the Ext JS 4.2.x library, under independent license.
 * License of Sencha Architect does not include license for Ext JS 4.2.x. For more
 * details see http://www.sencha.com/license or contact license@sencha.com.
 *
 * This file will be auto-generated each and everytime you save your project.
 *
 * Do NOT hand edit this file.
 */

Ext.define('Discovery.store.HostDiscoveryDB', {
	extend: 'Ext.data.Store',

	requires: [
		'Discovery.model.HostsDiscovery',
		'Ext.data.proxy.Ajax',
		'Ext.data.reader.Json',
		'Ext.util.Sorter'
	],

	constructor: function(cfg) {
		var me = this;
		cfg = cfg || {};
		me.callParent([Ext.apply({
			autoLoad: true,
			model: 'Discovery.model.HostsDiscovery',
			storeId: 'HostDiscovery',
			purgePageCount: 0,
			proxy: {
				type: 'ajax',
				api: {
					read: '/opmon/seagull/www/index.php/discovery/action/discovered_objects/'
				},
				pageParam: 'undefined',
				reader: {
					type: 'json',
					root: 'objects'
				}
			},
			listeners: {
				beforeload: {
					fn: me.onStoreBeforeLoad,
					scope: me
				},
				load: {
					fn: me.onStoreLoad,
					scope: me
				},
				add: {
					fn: me.onStoreAdd,
					scope: me
				},
				remove: {
					fn: me.onStoreRemove,
					scope: me
				},
				refresh: {
					fn: me.onStoreRefresh,
					scope: me
				}
			},
			sorters: {
				sorterFn: function(first, second) {
					var selected = Discovery.controller.components.discovery.Container.getGridSelectionMode().selected.items;

					var isSelected = function(xrec) {
						return (selected.some(function(yrec) {
							return xrec.get("host_name") === yrec.get("host_name");
						})) ? 1 : -1;
					};

					var verifyDate = function(xdate, ydate) {
						var xd = new Date(xdate);
						var yd = new Date(ydate);
						if (xd === yd) return 0;
						return xd < yd ? -1 : 1;
					};

					var updateBySelection = function() {
						var h1 = isSelected(first);
						var h2 = isSelected(second);

						if (h1 === -1 && h2 === -1) return verifyDate(first.get("updated_on"), second.get("updated_on"));
						if (h1 === h2) return 0;
						return h1 < h2 ? -1 : 1;
					};

					var updateByDate = function() {
						return verifyDate(first.get("updated_on"), second.get("updated_on"));
					};

					var f = Ext.ComponentQuery.query("#see_hosts_before")
					.reduce(function(f, el) {
						return (!el.getValue()) ? f : updateBySelection;
					}, updateByDate);

					// side effect
					return f();
				},
				direction: 'DESC',
				property: 'updated_on'
			}
		}, cfg)]);
	},

	onStoreBeforeLoad: function(store, operation, eOpts) {
		if (store.isLoading()) {
			return false;
		}

		Discovery.app.getController('components.discovery.Grid').setStateScroll();

		return true;
	},

	onStoreLoad: function(store, records, successful, eOpts) {
		this.timeLoaded = this.timeLoaded || new Date(Date.now());
		var tagsStore = Ext.getStore("TagsDiscoveryDB");
		Discovery.controller.components.discovery.Container.updateTitle();
		tagsStore.addBasedOnHostsRecords(records);
	},

	onStoreAdd: function(store, records, index, eOpts) {
		Ext.getStore("TagsDiscoveryDB").addBasedOnHostsRecords(records);
	},

	onStoreRemove: function(store, record, index, isMove, eOpts) {
		console.log("OQ");
		Ext.getStore("TagsDiscoveryDB").removeBasedOnHostsRecords([record]);
	},

	onStoreRefresh: function(store, eOpts) {
		Ext.getStore("TagsDiscoveryDB").addBasedOnHostsRecords(store.data.items);
	},

	getTimeLoaded: function() {
		return this.timeLoaded;
	},

	isFirstTime: function() {
		return this.firstTime = this.firstTime === undefined ? true : false;
	},

	compareTime: function(record) {
		return record.get('updated_on') > this.getTimeLoaded();
	},

	findFreshSpawn: function() {
		return this.isFirstTime() || this.data.items === undefined ? [] : this.data.items.filter(this.compareTime.bind(this));
	}

});