/*
 * File: app/store/TagsDiscoveryDB.js
 *
 * This file was generated by Sencha Architect
 * http://www.sencha.com/products/architect/
 *
 * This file requires use of the Ext JS 4.2.x library, under independent license.
 * License of Sencha Architect does not include license for Ext JS 4.2.x. For more
 * details see http://www.sencha.com/license or contact license@sencha.com.
 *
 * This file will be auto-generated each and everytime you save your project.
 *
 * Do NOT hand edit this file.
 */

Ext.define('Discovery.store.TagsDiscoveryDB', {
	extend: 'Ext.data.Store',

	requires: [
		'Discovery.model.TagsDiscovery',
		'Ext.util.Sorter'
	],

	constructor: function(cfg) {
		var me = this;
		cfg = cfg || {};
		me.callParent([Ext.apply({
			autoLoad: false,
			model: 'Discovery.model.TagsDiscovery',
			storeId: 'TagsDiscoveryDB',
			sorters: {
				sorterFn: function(first, second) {
					if (first.get("id") === "other") return 1;
					if (second.get("id") === "other") return -1;
					return first.get("id").localeCompare(second.get("id"));
				}
			}
		}, cfg)]);
	},

	addBasedOnHostsRecords: function(xs) {
		function getTagVal(obj, key) {
			return obj[key] || 0;
		}

		var tagsAsObject = xs.reduce(function(result, host) {
			var tags = host.get("discovered_tags");
			return Ext.apply(result, tags.reduce(function(acc, tag) {
				acc[tag] = getTagVal(acc, tag) + getTagVal(result, tag) + 1;
				return acc;
			}, {}));
		}, {});

		var tagsAsFields = Object.keys(tagsAsObject).reduce(function(result, key) {
			return result.concat({
				id: key,
				count: tagsAsObject[key]
			});
		}, []);

		this.removeAll();
		this.add(tagsAsFields);

		return tagsAsFields;
	},

	getTotal: function() {
		return this.data.items.reduce(function(total, tag) {
			return total + tag.get("count");
		}, 0);
	}

});