/*
 * File: app/view/components/discovery/DiscoveryContainer.js
 *
 * This file was generated by Sencha Architect
 * http://www.sencha.com/products/architect/
 *
 * This file requires use of the Ext JS 4.2.x library, under independent license.
 * License of Sencha Architect does not include license for Ext JS 4.2.x. For more
 * details see http://www.sencha.com/license or contact license@sencha.com.
 *
 * This file will be auto-generated each and everytime you save your project.
 *
 * Do NOT hand edit this file.
 */

Ext.define('Discovery.view.components.discovery.DiscoveryContainer', {
	extend: 'Ext.container.Container',
	alias: 'widget.components.discovery.discoverycontainer',

	requires: [
		'Discovery.view.components.settingstoolbar.Toolbar',
		'Discovery.view.components.discovery.Header',
		'Discovery.view.components.discovery.Grid',
		'Ext.toolbar.Toolbar',
		'Ext.tab.Panel',
		'Ext.tab.Tab',
		'Ext.grid.Panel',
		'Ext.view.View',
		'Ext.XTemplate'
	],

	rtl: false,
	autoScroll: true,

	layout: {
		type: 'vbox',
		align: 'stretch'
	},

	initComponent: function() {
		var me = this;

		Ext.applyIf(me, {
			items: [
				{
					xtype: 'container',
					items: [
						{
							xtype: 'components.settingstoolbar.toolbar',
							itemId: 'settingtoolbar'
						}
					]
				},
				{
					xtype: 'componentsdiscoveryheader'
				},
				{
					xtype: 'tabpanel',
					flex: 1,
					itemId: 'tabsView',
					margin: '-5 0 0 0',
					header: false,
					activeTab: 1,
					removePanelHeader: false,
					items: [
						{
							xtype: 'panel',
							itemId: 'tabsview-grid',
							header: false,
							title: Ext.locale.translate('Detailed'),
							layout: {
								type: 'vbox',
								align: 'stretch'
							},
							items: [
								{
									xtype: 'components.discovery.grid',
									itemId: 'discoveryGrid',
									flex: 1
								},
								{
									xtype: 'container',
									margins: '15 0 0 0',
									height: 40,
									id: 'controlContainer',
									layout: {
										type: 'hbox',
										align: 'middle',
										padding: '0 10'
									},
									items: [
										{
											xtype: 'button',
											handler: function(button, event) {
												hostNames = [];

												grid = Ext.ComponentQuery.query("#discoveryGrid #gridView")[0].getSelectionModel();
												selected = grid.getSelection();
												for(i=0; i<selected.length; i++) {
													hostNames.push(selected[i].data.host_name);
												}

												if (hostNames.length === 0) {
													return;
												}

												Discovery.app.getController('components.discovery.Job').removalRequest(selected);
											},
											cls: 'button-weak',
											disabled: true,
											id: 'removeElements',
											text: 'Remover elementos selecionados',
											listeners: {
												beforerender: {
													fn: me.onRemoveElementsBeforeRender,
													scope: me
												}
											}
										},
										{
											xtype: 'button',
											handler: function(button, event) {
												Discovery.controller.components.discovery.Container.processHosts();
											},
											disabled: true,
											id: 'processBtn',
											margin: '0 0 0 10',
											text: 'Configurar elementos selecionados',
											listeners: {
												beforerender: {
													fn: me.onProcessBtnBeforeRender,
													scope: me
												}
											}
										}
									]
								}
							]
						},
						{
							xtype: 'panel',
							itemId: 'tabsview-board',
							header: false,
							title: Ext.locale.translate('Grouped'),
							layout: {
								type: 'vbox',
								align: 'stretch'
							},
							items: [
								{
									xtype: 'dataview',
									flex: 1,
									itemId: 'tags_dataview',
									padding: '30 20 10 10',
									autoScroll: true,
									deferEmptyText: false,
									itemCls: 'x-dataview-item cat-square',
									itemSelector: 'div',
									itemTpl: Ext.create('Ext.XTemplate', 
										'<tpl>',
										'    <span class="tag-icon">',
										'		<img src="/opmon/opcfg/logos/devices_{[this.getSrc(values.id)]}.png" />',
										'		<span class="tag-name">{name}</span>',
										'	</span>',
										'	<span class="tag-info">',
										'		<span class="tag-count">{count}</span>',
										'	</span>',
										'</tpl>',
										{
											getSrc: function(id) {
												return Discovery.controller.components.discovery.Container.getSomeExistingTag([id]);
											}
										}
									),
									store: 'TagsDiscoveryDB',
									listeners: {
										beforerender: {
											fn: me.onDataviewBeforeRender,
											scope: me
										}
									}
								}
							]
						}
					]
				}
			]
		});

		me.callParent(arguments);
	},

	onRemoveElementsBeforeRender: function(component, eOpts) {
		component.text = l["Remove selected elements"];
	},

	onProcessBtnBeforeRender: function(component, eOpts) {
		component.text = l["Configure selected elements"];
	},

	onDataviewBeforeRender: function(component, eOpts) {
		var link = "<a class=\"empty-text-link\" onclick=\"Discovery.app.getController('components.settingstoolbar.Toolbar').onNewIpRangeClick()\">%click%</a>"
			.replace("%click%", Ext.locale.translate('click here'));

		component.emptyText = Ext.locale.translate('There has not been any elements discovered yet. %link% in order to start the discovery process.')
			.replace("%link%", link);
	}

});