/*
 * File: app/view/components/discovery/Grid.js
 *
 * This file was generated by Sencha Architect
 * http://www.sencha.com/products/architect/
 *
 * This file requires use of the Ext JS 4.2.x library, under independent license.
 * License of Sencha Architect does not include license for Ext JS 4.2.x. For more
 * details see http://www.sencha.com/license or contact license@sencha.com.
 *
 * This file will be auto-generated each and everytime you save your project.
 *
 * Do NOT hand edit this file.
 */

Ext.define('Discovery.view.components.discovery.Grid', {
	extend: 'Ext.grid.Panel',
	alias: 'widget.components.discovery.grid',

	requires: [
		'Ext.grid.column.Date',
		'Ext.grid.View',
		'Ext.selection.CheckboxModel',
		'Ext.grid.plugin.BufferedRenderer',
		'Ext.toolbar.Toolbar',
		'Ext.grid.column.Action'
	],

	itemId: 'gridDetailed',
	autoScroll: true,
	collapsible: true,
	header: false,
	title: Ext.locale.translate('Elementos descobertos'),
	titleCollapse: false,
	columnLines: true,
	forceFit: true,
	store: 'HostDiscoveryDB',

	initComponent: function() {
		var me = this;

		Ext.applyIf(me, {
			defaults: {
				enableColumnHide: false,
				hideable: false,
				flex: 1
			},
			columns: [
				{
					xtype: 'gridcolumn',
					renderer: function(value, metaData, record, rowIndex, colIndex, store, view) {
						metaData.tdAttr = 'data-qtip="'+ value +'"';
						return'<div class="icon-tag"><img src="/opmon/opcfg/logos/devices_'+ value +'.png" /></div>';
					},
					itemId: 'tagIcon',
					width: 50,
					dataIndex: 'tag',
					text: Ext.locale.translate('OS'),
					tooltip: Ext.locale.translate('Operational system')
				},
				{
					xtype: 'gridcolumn',
					renderer: function(value, metaData, record, rowIndex, colIndex, store, view) {
						var state = record.get('monitoringState');
						var description = Discovery.app.getController('components.discovery.Grid').getMonitoringStateDescription(state);
						metaData.tdAttr = 'data-qtip="'+ description +'"';
						return '<div class="monitoring-state state-'+ state +'"></div>';
					},
					itemId: 'monitoringState1',
					width: 50,
					dataIndex: 'monitoringState',
					text: Ext.locale.translate('Monitored'),
					tooltip: Ext.locale.translate('Grey color: the device hasn\'t been added to monitoring yet. Green color: the device is already being monitored by OpMon.')
				},
				{
					xtype: 'datecolumn',
					width: 120,
					dataIndex: 'updated_on',
					text: Ext.locale.translate('Updated on'),
					tooltip: Ext.locale.translate('Updated on'),
					format: 'd/m/y - H:i'
				},
				{
					xtype: 'gridcolumn',
					width: 200,
					dataIndex: 'host_name',
					text: Ext.locale.translate('Host Name'),
					tooltip: Ext.locale.translate('Host Name')
				},
				{
					xtype: 'gridcolumn',
					width: 120,
					dataIndex: 'host_ip',
					groupable: false,
					text: Ext.locale.translate('IP Address'),
					tooltip: Ext.locale.translate('IP Address')
				},
				{
					xtype: 'gridcolumn',
					renderer: function(value, metaData, record, rowIndex, colIndex, store, view) {
						metaData.tdAttr = 'data-qtip="' + value + '"';
						return value;
					},
					cls: '',
					sortable: true,
					dataIndex: 'alias',
					tdCls: 'even-column',
					text: Ext.locale.translate('Description'),
					tooltip: Ext.locale.translate('Description'),
					flex: 1
				},
				{
					xtype: 'actioncolumn',
					itemId: 'actionColumn',
					width: 50,
					items: [
						{
							icon: 'app/resources/refresh.png',
							iconCls: 'ico-rediscovery',
							tooltip: Ext.locale.translate('Rediscovery')
						},
						{
							icon: 'app/resources/ico-excluir.png',
							iconCls: 'ico-excluir',
							tooltip: Ext.locale.translate('Remove')
						}
					]
				},
				{
					xtype: 'actioncolumn',
					id: 'informationIcon',
					width: 30,
					items: [
						{
							handler: function(view, rowIndex, colIndex, item, e, record, row) {

								var x = Ext.create("Discovery.view.components.discovery.detailsAccordion");

								var disksDetails;
								var processesDetails;
								var portDetails;
								var servicesDetails;
								var detailsPanel;
								var othersPanel;

								var detailsAccordion = Ext.ComponentQuery.query("#detailsAccordion")[0];
								detailsAccordion.setTitle(Ext.locale.translate('Details of') + " " +record.get('host_name'));

								disksDetails = Discovery.getApplication().getViewControllerController().getDisksDetails();
								disksDetails.reconfigure(record.data.disks);

								processesDetails = Discovery.getApplication().getViewControllerController().getProcessesDetails();
								processesDetails.reconfigure(record.data.processes);

								portDetails = Discovery.getApplication().getViewControllerController().getPortDetails();
								portDetails.reconfigure(record.data.open_ports);

								servicesDetails = Discovery.getApplication().getViewControllerController().getServicesDetails();
								servicesDetails.reconfigure(record.data.services);

								interfacesDetails = Discovery.getApplication().getViewControllerController().getInterfacesDetails();
								interfacesDetails.reconfigure(record.data.network_interfaces);

								othersPanel = Discovery.getApplication().getViewControllerController().getOthersDetails();
								othersPanel.reconfigure(record.data.others);

								x.show();
							},
							icon: '../../../statusgrid/templates/imgs/ico-info.png',
							iconCls: 'informationClass',
							tooltip: Ext.locale.translate('Show details')
						}
					]
				}
			],
			viewConfig: {
				itemId: 'gridView',
				deferEmptyText: false,
				disableSelection: false,
				preserveScrollOnRefresh: true,
				trackOver: false,
				enableTextSelection: false,
				listeners: {
					bodyscroll: {
						fn: me.onGridViewBodyscroll,
						scope: me
					},
					beforerender: {
						fn: me.onGridViewBeforeRender,
						scope: me
					}
				}
			},
			selModel: Ext.create('Ext.selection.CheckboxModel', {
				allowDeselect: true,
				pruneRemoved: false,
				toggleOnClick: false,
				ignoreRightMouseSelection: true,
				checkOnly: true,
				showHeaderCheckbox: true,
				listeners: {
					selectionchange: {
						fn: me.onCheckboxModelSelectionChange,
						scope: me
					}
				}
			}),
			plugins: [
				Ext.create('Ext.grid.plugin.BufferedRenderer', {

				})
			],
			dockedItems: [
				{
					xtype: 'toolbar',
					dock: 'top'
				}
			],
			listeners: {
				itemmouseenter: {
					fn: me.onTestandoItemMouseEnter,
					scope: me
				}
			}
		});

		me.callParent(arguments);
	},

	onGridViewBodyscroll: function(view) {
		var timeout;
		if (timeout) {
			clearTimeout(timeout);
		}
		var timeout = setTimeout(function(){
			Discovery.app.getController("components.discovery.Grid").checkNewElements();
		}, 1000);
	},

	onGridViewBeforeRender: function(component, eOpts) {
		var link = "<a class=\"empty-text-link\" onclick=\"Discovery.app.getController('components.settingstoolbar.Toolbar').onNewIpRangeClick()\">%click%</a>"
			.replace("%click%", Ext.locale.translate('click here'));

		component.emptyText = Ext.locale.translate('There has not been any elements discovered yet. %link% in order to start the discovery process.')
			.replace("%link%", link);
	},

	onCheckboxModelSelectionChange: function(model, selected, eOpts) {
		countSelected = selected.length;
		// document.getElementById('nSelectedElements').innerHTML = countSelected;
		if (countSelected > 0) {
			Ext.getCmp('processBtn').setDisabled(false);
			Ext.getCmp('removeElements').setDisabled(false);
		} else {
			Ext.getCmp('processBtn').setDisabled(true);
			Ext.getCmp('removeElements').setDisabled(true);
		}
	},

	onTestandoItemMouseEnter: function(dataview, record, item, index, e, eOpts) {
		this.getView().focusRow(index);

	}

});