/*
 * File: app/view/components/discovery/Toolbar.js
 *
 * This file was generated by Sencha Architect
 * http://www.sencha.com/products/architect/
 *
 * This file requires use of the Ext JS 4.2.x library, under independent license.
 * License of Sencha Architect does not include license for Ext JS 4.2.x. For more
 * details see http://www.sencha.com/license or contact license@sencha.com.
 *
 * This file will be auto-generated each and everytime you save your project.
 *
 * Do NOT hand edit this file.
 */

Ext.define('Discovery.view.components.discovery.Toolbar', {
	extend: 'Ext.toolbar.Toolbar',
	alias: 'widget.components.discovery.toolbar',

	requires: [
		'Ext.toolbar.TextItem',
		'Ext.form.field.Checkbox',
		'Ext.button.Button',
		'Ext.toolbar.Separator',
		'Ext.toolbar.Spacer'
	],

	baseCls: 'x-panel-header',
	height: 33,
	margin: 0,
	padding: 0,

	layout: {
		type: 'hbox',
		pack: 'end'
	},

	initComponent: function() {
		var me = this;

		Ext.applyIf(me, {
			items: [
				{
					xtype: 'tbtext',
					id: 'titleHeaderChange',
					text: Ext.locale.translate('Grouped')
				},
				{
					xtype: 'checkboxfield',
					itemId: 'see_hosts_before',
					style: 'color:#fff;',
					fieldLabel: 'Label',
					hideLabel: true,
					boxLabel: Ext.locale.translate('View hosts before monitoring')
				},
				{
					xtype: 'button',
					handler: function(button, e) {
						var controller = Discovery.controller.components.discovery.Container;
						return controller.changeTo("#tabsview-board", "show", controller.totalTagsTitle);
					},
					margins: '',
					margin: 0,
					enableToggle: true,
					icon: 'app/resources/bricks.png',
					pressed: true,
					toggleGroup: 'viewGroupButtons',
					tooltip: Ext.locale.translate('Grouped by tag')
				},
				{
					xtype: 'button',
					handler: function(button, e) {
						var controller = Discovery.controller.components.discovery.Container;
						return controller.changeTo("#tabsview-grid", "hide", controller.totalDevicesTitle);
					},
					margins: '',
					margin: '0 8 0 5',
					allowDepress: false,
					enableToggle: true,
					icon: 'app/resources/table.png',
					toggleGroup: 'viewGroupButtons',
					tooltip: Ext.locale.translate('Detailed view')
				},
				{
					xtype: 'tbseparator'
				},
				{
					xtype: 'button',
					handler: function(button, e) {
						Discovery.getApplication().getHostDiscoveryDBStore().reload();
					},
					margins: '',
					margin: 0,
					icon: 'app/resources/refresh.png',
					tooltip: Ext.locale.translate('Refresh')
				},
				{
					xtype: 'tbspacer',
					id: 'littleSpacer',
					minWidth: 5
				}
			]
		});

		me.callParent(arguments);
	}

});