/*
 * File: app/view/components/settingstoolbar/Toolbar.js
 *
 * This file was generated by Sencha Architect
 * http://www.sencha.com/products/architect/
 *
 * This file requires use of the Ext JS 4.2.x library, under independent license.
 * License of Sencha Architect does not include license for Ext JS 4.2.x. For more
 * details see http://www.sencha.com/license or contact license@sencha.com.
 *
 * This file will be auto-generated each and everytime you save your project.
 *
 * Do NOT hand edit this file.
 */

Ext.define('Discovery.view.components.settingstoolbar.Toolbar', {
	extend: 'Ext.toolbar.Toolbar',
	alias: 'widget.components.settingstoolbar.toolbar',

	requires: [
		'Ext.container.Container',
		'Ext.button.Button',
		'Ext.toolbar.Separator',
		'Ext.form.field.Checkbox',
		'Ext.toolbar.Spacer',
		'Ext.form.field.Trigger'
	],

	cls: 'bg-gray-header',
	padding: '0 15 15 15',

	layout: {
		type: 'hbox',
		align: 'bottom'
	},

	initComponent: function() {
		var me = this;

		Ext.applyIf(me, {
			items: [
				{
					xtype: 'container',
					items: [
						{
							xtype: 'button',
							itemId: 'newIpRange',
							text: Ext.locale.translate('Start new Discovery')
						}
					]
				},
				{
					xtype: 'tbseparator'
				},
				{
					xtype: 'container',
					height: 40,
					layout: {
						type: 'hbox',
						align: 'bottom'
					},
					items: [
						{
							xtype: 'button',
							cls: 'auth-button warn-button',
							itemId: 'registeredAuthButton',
							text: Ext.locale.translate('Registered Authentications')
						},
						{
							xtype: 'container',
							hidden: true,
							html: '<div style="position: absolute; top: -37px; cursor:default; right: 0; background: #f3ba25; padding: 1px 7px; border-radius: 50%; font-weight: bold;">!</div>',
							listeners: {
								afterrender: {
									fn: me.onContainerAfterRender1,
									scope: me
								}
							}
						}
					]
				},
				{
					xtype: 'tbseparator',
					hidden: true,
					itemId: 'discoveryRunningSpacer'
				},
				{
					xtype: 'button',
					cls: 'auth-button discovery-running-button',
					itemId: 'discoveryRunningButton',
					style: '{ border: #afafaf solid 1px }',
					icon: '/opmon/oplib/libjs/extjs4/resources/opmon-default/images/loadmask/loading.gif',
					text: Ext.locale.translate('Discovery running')
				},
				{
					xtype: 'tbseparator'
				},
				{
					xtype: 'checkboxfield',
					id: 'autoDiscovery',
					itemId: 'autoDiscoveryCheckbox',
					labelAlign: 'right',
					boxLabel: Ext.locale.translate('Autodiscover enabled'),
					listeners: {
						beforerender: {
							fn: me.onAutoDiscoveryBeforeRender,
							scope: me
						}
					}
				},
				{
					xtype: 'tbseparator'
				},
				{
					xtype: 'container',
					cls: 'teste-aaaa',
					html: '<a href="http://kb.opservices.com.br/knowledge-base/wizard/" target="_blank"><img src="../../../opinterface/templates/imgs/help.png"></a>',
					listeners: {
						afterrender: {
							fn: me.onContainerAfterRender,
							scope: me
						},
						beforerender: {
							fn: me.onContainerBeforeRender,
							scope: me
						}
					}
				},
				{
					xtype: 'tbspacer',
					flex: 1
				},
				{
					xtype: 'triggerfield',
					margins: '0 -7 0 0 ',
					border: true,
					maxWidth: 400,
					width: 200,
					fieldLabel: 'Filtrar',
					hideLabel: true,
					labelSeparator: ' ',
					labelWidth: 40,
					emptyText: 'Filtrar elementos descobertos',
					enableKeyEvents: true,
					triggerCls: 'search-trigger',
					listeners: {
						keyup: {
							fn: me.onTextfieldKeyup,
							scope: me
						},
						beforerender: {
							fn: me.onTriggerfieldBeforeRender,
							scope: me
						}
					}
				}
			]
		});

		me.callParent(arguments);
	},

	onContainerAfterRender1: function(component, eOpts) {
		function updateIcon(communities) {
			var hasAnyCommunityAdded = communities.data.items.some(function(record) {
				return record.get("community_id") !== 1;
			});

			var f = (!hasAnyCommunityAdded) ? "show" : "hide";

			component[f]();
		}

		Ext.create('Ext.tip.ToolTip', {
			target: component.getEl(),
			html: Ext.locale.translate('Improve your network discovery  by registering its authentications')
		});

		Authentication.app.getStore("Community").on("refresh", updateIcon);
	},

	onAutoDiscoveryBeforeRender: function(component, eOpts) {
		 component.setBoxLabel(l["Autodiscovery enabled"]);
	},

	onContainerAfterRender: function(component, eOpts) {
		Ext.QuickTips.register({
			target: component.getEl(),
			text: Ext.locale.translate('%link%Click here%endlink% if you need help').replace("%link%", "").replace("%endlink%", "")
		});
	},

	onContainerBeforeRender: function(component, eOpts) {
		component.update(
			'<a href="http://kb.'
				.concat ((Ext.locale.lang === "en_US") ? "opservices.com" : "opservices.com.br")
				.concat ('/knowledge-base/wizard/" target="_blank"><img src="../../../opinterface/templates/imgs/help.png"></a>')
		);
	},

	onTextfieldKeyup: function(textfield, e, eOpts) {
		Discovery.filterValue = textfield.getValue();

		if (Discovery.filter_timeout !== null) {
			clearTimeout(Discovery.filter_timeout);
			Discovery.filter_timeout = null;
		}

		Discovery.filter_timeout = setTimeout(Discovery.getApplication().getViewControllerController().applyFilter,900);
	},

	onTriggerfieldBeforeRender: function(component, eOpts) {
		component.emptyText = l["Filter discovered elements"];
	}

});