/*
 * File: app/view/components/settingstoolbar/snmp/Form.js
 *
 * This file was generated by Sencha Architect
 * http://www.sencha.com/products/architect/
 *
 * This file requires use of the Ext JS 4.2.x library, under independent license.
 * License of Sencha Architect does not include license for Ext JS 4.2.x. For more
 * details see http://www.sencha.com/license or contact license@sencha.com.
 *
 * This file will be auto-generated each and everytime you save your project.
 *
 * Do NOT hand edit this file.
 */

Ext.define('Discovery.view.components.settingstoolbar.snmp.Form', {
	extend: 'Ext.form.Panel',
	alias: 'widget.components.snmp.form',

	requires: [
		'Ext.form.FieldSet',
		'Ext.form.field.ComboBox',
		'Ext.panel.Tool',
		'Ext.toolbar.Toolbar',
		'Ext.button.Button'
	],

	cls: 'tab-sub-header',
	itemId: 'snmpForm',
	autoScroll: true,
	header: false,
	title: 'Definir os parâmetros da Comunidade',
	titleCollapse: false,

	layout: {
		type: 'vbox',
		align: 'stretch',
		padding: '20 20 0 20'
	},

	initComponent: function() {
		var me = this;

		Ext.applyIf(me, {
			items: [
				{
					xtype: 'fieldset',
					id: 'formSnmpVersion',
					items: [
						{
							xtype: 'combobox',
							anchor: '100%',
							id: 'formSnmpVersionSelect',
							fieldLabel: 'Tipo de autenticação',
							name: 'snmp_version',
							store: [
								[
									'1',
									'SNMP v1'
								],
								[
									'2c',
									'SNMP v2c'
								],
								[
									'3',
									'SNMP v3'
								],
								[
									'credentials',
									'User and Password'
								]
							],
							listeners: {
								change: {
									fn: me.onFormSnmpVersionSelectChange,
									scope: me
								},
								beforerender: {
									fn: me.onFormSnmpVersionSelectBeforeRender,
									scope: me
								}
							}
						}
					],
					listeners: {
						beforerender: {
							fn: me.onFormSnmpVersionBeforeRender,
							scope: me
						}
					}
				},
				{
					xtype: 'fieldset',
					id: 'formSnmpAuth',
					width: 338,
					title: 'teste',
					items: [
						{
							xtype: 'textfield',
							anchor: '100%',
							fieldLabel: 'Name',
							name: 'name',
							allowBlank: false,
							allowOnlyWhitespace: false
						},
						{
							xtype: 'textfield',
							anchor: '100%',
							id: 'formSnmpAuthCommunity',
							fieldLabel: 'Comunidade',
							name: 'community',
							enforceMaxLength: false,
							listeners: {
								beforerender: {
									fn: me.onFormSnmpAuthCommunityBeforeRender,
									scope: me
								}
							}
						},
						{
							xtype: 'textfield',
							anchor: '100%',
							hidden: true,
							id: 'formCredentialUser',
							fieldLabel: 'Usuário',
							name: 'credential_user',
							enforceMaxLength: false,
							listeners: {
								beforerender: {
									fn: me.onFormSnmpAuthCommunityBeforeRender1,
									scope: me
								}
							}
						},
						{
							xtype: 'textfield',
							anchor: '100%',
							hidden: true,
							id: 'formCredentialPass',
							fieldLabel: 'Senha',
							name: 'credential_pass',
							listeners: {
								beforerender: {
									fn: me.onFormSnmpAuthCommunityBeforeRender11,
									scope: me
								}
							}
						},
						{
							xtype: 'combobox',
							anchor: '100%',
							hidden: true,
							id: 'formSnmpAuthProtocol',
							fieldLabel: 'Protocolo',
							name: 'authentication_protocol',
							store: [
								'SHA',
								'MD5'
							],
							listeners: {
								beforerender: {
									fn: me.onFormSnmpAuthProtocolBeforeRender,
									scope: me
								}
							}
						},
						{
							xtype: 'textfield',
							anchor: '100%',
							hidden: true,
							id: 'formSnmpAuthPass',
							fieldLabel: 'Senha',
							name: 'authentication_passphrase',
							listeners: {
								beforerender: {
									fn: me.onFormSnmpAuthPassBeforeRender,
									scope: me
								}
							}
						}
					],
					listeners: {
						beforerender: {
							fn: me.onFormSnmpAuthBeforeRender,
							scope: me
						}
					}
				},
				{
					xtype: 'fieldset',
					hidden: true,
					id: 'formSnmpSecurity',
					width: 150,
					title: 'Segurança',
					items: [
						{
							xtype: 'combobox',
							anchor: '100%',
							id: 'formSnmpSecurityLevel',
							fieldLabel: 'Level',
							name: 'security_level',
							store: [
								'authPriv',
								'authNoPriv',
								'noAuthNoPriv'
							],
							listeners: {
								beforerender: {
									fn: me.onFormSnmpSecurityLevelBeforeRender,
									scope: me
								}
							}
						},
						{
							xtype: 'textfield',
							anchor: '100%',
							id: 'formSnmpSecurityContext',
							fieldLabel: 'Contexto',
							name: 'context_name',
							listeners: {
								beforerender: {
									fn: me.onFormSnmpSecurityContextBeforeRender,
									scope: me
								}
							}
						},
						{
							xtype: 'textfield',
							anchor: '100%',
							id: 'formSnmpSecurityUser',
							fieldLabel: 'Usuário',
							name: 'security_username',
							enforceMaxLength: false,
							maxLengthText: '',
							listeners: {
								beforerender: {
									fn: me.onFormSnmpSecurityUserBeforeRender,
									scope: me
								}
							}
						}
					],
					listeners: {
						beforerender: {
							fn: me.onFormSnmpSecurityBeforeRender,
							scope: me
						}
					}
				},
				{
					xtype: 'fieldset',
					height: 107,
					hidden: true,
					id: 'formSnmpPrivacy',
					title: 'Privacidade',
					items: [
						{
							xtype: 'combobox',
							anchor: '100%',
							id: 'formSnmpPrivacyProtocol',
							fieldLabel: 'Protocolo',
							name: 'privacy_protocol',
							store: [
								'AES',
								'DES'
							],
							listeners: {
								beforerender: {
									fn: me.onFormSnmpPrivacyProtocolBeforeRender,
									scope: me
								}
							}
						},
						{
							xtype: 'textfield',
							anchor: '100%',
							id: 'formSnmpPrivacyPass',
							fieldLabel: 'Senha',
							name: 'privacy_protocol_passphrase',
							listeners: {
								beforerender: {
									fn: me.onFormSnmpPrivacyPassBeforeRender,
									scope: me
								}
							}
						},
						{
							xtype: 'textfield',
							anchor: '100%',
							id: 'formSnmpPrivacyDestiny',
							fieldLabel: 'Destino',
							name: 'destination_engine',
							listeners: {
								beforerender: {
									fn: me.onFormSnmpPrivacyDestinyBeforeRender,
									scope: me
								}
							}
						}
					],
					listeners: {
						beforerender: {
							fn: me.onFormSnmpPrivacyBeforeRender,
							scope: me
						}
					}
				}
			],
			tools: [
				{
					xtype: 'tool',
					id: 'helpFormSnmp',
					tooltip: 'Ajuda',
					type: 'help'
				}
			],
			listeners: {
				show: {
					fn: me.onFormSnmpShow,
					scope: me
				}
			},
			dockedItems: [
				{
					xtype: 'toolbar',
					flex: 1,
					dock: 'bottom',
					layout: {
						type: 'hbox',
						pack: 'end'
					},
					items: [
						{
							xtype: 'button',
							id: 'formSnmpCancel',
							text: Ext.locale.translate('Cancel')
						},
						{
							xtype: 'container',
							id: 'formSnmpCancelContainer',
							items: [
								{
									xtype: 'button',
									id: 'formSnmpSave',
									text: Ext.locale.translate('Save')
								}
							]
						}
					]
				}
			]
		});

		me.callParent(arguments);
	},

	onFormSnmpVersionSelectChange: function(field, newValue, oldValue, eOpts) {
		if (newValue === '3') {
			Ext.getCmp('formSnmpAuthCommunity').setVisible(false);
			Ext.getCmp('formSnmpAuthProtocol').setVisible(true);
			Ext.getCmp('formSnmpAuthPass').setVisible(true);
			Ext.getCmp('formSnmpSecurity').setVisible(true);
			Ext.getCmp('formSnmpPrivacy').setVisible(true);
			Ext.getCmp('formCredentialUser').setVisible(false);
			Ext.getCmp('formCredentialPass').setVisible(false);
		} else if (newValue === 'credentials') {
			Ext.getCmp('formSnmpAuthCommunity').setVisible(false);
			Ext.getCmp('formSnmpAuthProtocol').setVisible(false);
			Ext.getCmp('formSnmpAuthPass').setVisible(false);
			Ext.getCmp('formSnmpSecurity').setVisible(false);
			Ext.getCmp('formSnmpPrivacy').setVisible(false);
			Ext.getCmp('formCredentialUser').setVisible(true);
			Ext.getCmp('formCredentialPass').setVisible(true);
		} else {
			Ext.getCmp('formSnmpAuthCommunity').setVisible(true);
			Ext.getCmp('formSnmpAuthProtocol').setVisible(false);
			Ext.getCmp('formSnmpAuthPass').setVisible(false);
			Ext.getCmp('formSnmpSecurity').setVisible(false);
			Ext.getCmp('formSnmpPrivacy').setVisible(false);
			Ext.getCmp('formCredentialUser').setVisible(false);
			Ext.getCmp('formCredentialPass').setVisible(false);
		}
	},

	onFormSnmpVersionSelectBeforeRender: function(component, eOpts) {
		component.fieldLabel = l["Authentication Mode"];
	},

	onFormSnmpVersionBeforeRender: function(component, eOpts) {
		component.setTitle(l["Authentication Mode"]);
	},

	onFormSnmpAuthCommunityBeforeRender: function(component, eOpts) {
		component.fieldLabel = l["Community"];
	},

	onFormSnmpAuthCommunityBeforeRender1: function(component, eOpts) {
		component.fieldLabel = l["User"];
	},

	onFormSnmpAuthCommunityBeforeRender11: function(component, eOpts) {
		component.fieldLabel = l["Password"];
	},

	onFormSnmpAuthProtocolBeforeRender: function(component, eOpts) {
		component.fieldLabel = l["Protocol"];
	},

	onFormSnmpAuthPassBeforeRender: function(component, eOpts) {
		component.fieldLabel = l["Password"];
	},

	onFormSnmpAuthBeforeRender: function(component, eOpts) {
		component.setTitle(l["Authentication"]);
	},

	onFormSnmpSecurityLevelBeforeRender: function(component, eOpts) {
		component.fieldLabel = l["Level"];
	},

	onFormSnmpSecurityContextBeforeRender: function(component, eOpts) {
		component.fieldLabel = l["Context"];
	},

	onFormSnmpSecurityUserBeforeRender: function(component, eOpts) {
		component.fieldLabel = l["User"];
	},

	onFormSnmpSecurityBeforeRender: function(component, eOpts) {
		component.setTitle(l["Security"]);
	},

	onFormSnmpPrivacyProtocolBeforeRender: function(component, eOpts) {
		component.fieldLabel = l["Protocol"];
	},

	onFormSnmpPrivacyPassBeforeRender: function(component, eOpts) {
		component.fieldLabel = l["Password"];
	},

	onFormSnmpPrivacyDestinyBeforeRender: function(component, eOpts) {
		component.fieldLabel = l["Destination"];
	},

	onFormSnmpPrivacyBeforeRender: function(component, eOpts) {
		component.setTitle(l["Privacy"]);
	},

	onFormSnmpShow: function(component, eOpts) {
		var versionValue = Ext.getCmp('formSnmpVersionSelect').value;
		if (versionValue === '3') {
			Ext.getCmp('formSnmpAuthCommunity').setVisible(false);
			Ext.getCmp('formSnmpAuthProtocol').setVisible(true);
			Ext.getCmp('formSnmpAuthPass').setVisible(true);
			Ext.getCmp('formSnmpSecurity').setVisible(true);
			Ext.getCmp('formSnmpPrivacy').setVisible(true);
		} else {
			Ext.getCmp('formSnmpAuthCommunity').setVisible(true);
			Ext.getCmp('formSnmpAuthProtocol').setVisible(false);
			Ext.getCmp('formSnmpAuthPass').setVisible(false);
			Ext.getCmp('formSnmpSecurity').setVisible(false);
			Ext.getCmp('formSnmpPrivacy').setVisible(false);
		}
	}

});