/*
 * File: app/view/components/settingstoolbar/snmp/List.js
 *
 * This file was generated by Sencha Architect
 * http://www.sencha.com/products/architect/
 *
 * This file requires use of the Ext JS 4.2.x library, under independent license.
 * License of Sencha Architect does not include license for Ext JS 4.2.x. For more
 * details see http://www.sencha.com/license or contact license@sencha.com.
 *
 * This file will be auto-generated each and everytime you save your project.
 *
 * Do NOT hand edit this file.
 */

Ext.define('Discovery.view.components.settingstoolbar.snmp.List', {
	extend: 'Ext.grid.Panel',
	alias: 'widget.components.snmp.list',

	requires: [
		'Ext.grid.column.Template',
		'Ext.XTemplate',
		'Ext.grid.View',
		'Ext.grid.column.Action',
		'Ext.toolbar.Toolbar',
		'Ext.button.Button'
	],

	id: 'authList',
	forceFit: false,
	store: 'SNMPCommunityDB',

	initComponent: function() {
		var me = this;

		Ext.applyIf(me, {
			columns: [
				{
					xtype: 'gridcolumn',
					width: 50,
					dataIndex: 'community_id',
					text: Ext.locale.translate('Community ID'),
					tooltip: Ext.locale.translate('Community ID')
				},
				{
					xtype: 'gridcolumn',
					hidden: true,
					dataIndex: 'community',
					text: Ext.locale.translate('Community'),
					tooltip: Ext.locale.translate('Community'),
					flex: 1
				},
				{
					xtype: 'gridcolumn',
					dataIndex: 'name',
					text: Ext.locale.translate('Name'),
					tooltip: Ext.locale.translate('Name'),
					flex: 1
				},
				{
					xtype: 'templatecolumn',
					tpl: [
						'<tpl if="snmp_version == \'credentials\'">',
						'	<span class=\'snmp-item\'>User and Pass</span>',
						'<tpl else>',
						'	<span class=\'snmp-item\'>SNMP v{snmp_version}</span>',
						'</tpl>'
					],
					width: 100,
					dataIndex: 'snmp_version',
					text: Ext.locale.translate('Version'),
					tooltip: Ext.locale.translate('Version')
				},
				{
					xtype: 'actioncolumn',
					itemId: 'actionCol',
					width: 50,
					items: [
						{
							icon: 'app/resources/ico-editar.png',
							iconCls: 'ico-editar',
							tooltip: Ext.locale.translate('Edit')
						},
						{
							icon: 'app/resources/ico-excluir.png',
							iconCls: 'ico-excluir',
							tooltip: Ext.locale.translate('Remove')
						}
					]
				}
			],
			viewConfig: {
				deferEmptyText: false,
				emptyText: ''+Ext.locale.translate('No has any authentication registered. Configure the first one')+' <a class="empty-text-link" onclick="Discovery.app.getController(\'components.settingstoolbar.SnmpWindow\').activeForm()">'+Ext.locale.translate('here')+'</a>.'
			},
			dockedItems: [
				{
					xtype: 'toolbar',
					dock: 'bottom',
					layout: {
						type: 'hbox',
						padding: '5 0'
					},
					items: [
						{
							xtype: 'container',
							items: [
								{
									xtype: 'button',
									itemId: 'addSnmp',
									text: Ext.locale.translate('Register new authentication')
								}
							]
						}
					]
				}
			]
		});

		me.callParent(arguments);
	}

});