/*
 * File: app/view/discoveryView.js
 *
 * This file was generated by Sencha Architect
 * http://www.sencha.com/products/architect/
 *
 * This file requires use of the Ext JS 4.2.x library, under independent license.
 * License of Sencha Architect does not include license for Ext JS 4.2.x. For more
 * details see http://www.sencha.com/license or contact license@sencha.com.
 *
 * This file will be auto-generated each and everytime you save your project.
 *
 * Do NOT hand edit this file.
 */

Ext.define('Discovery.view.discoveryView', {
	extend: 'Ext.container.Container',
	alias: 'widget.discoveryview',

	requires: [
		'Discovery.view.components.discovery.DiscoveryContainer',
		'Ext.panel.Panel',
		'Ext.panel.Tool',
		'Ext.toolbar.Toolbar',
		'Ext.button.Button'
	],

	id: 'discoveryView',
	itemId: 'discoveryView',

	layout: {
		type: 'vbox',
		align: 'stretch'
	},

	initComponent: function() {
		var me = this;

		Ext.applyIf(me, {
			items: [
				{
					xtype: 'panel',
					cls: 'top_bar',
					height: 36,
					id: 'header',
					padding: '0 0 5 0',
					header: false,
					title: 'Configuração inicial do OpMon 6.0',
					layout: {
						type: 'hbox',
						align: 'stretch',
						pack: 'center'
					},
					tools: [
						{
							xtype: 'tool',
							id: 'helpButton4',
							tooltip: 'Ajuda',
							type: 'help'
						}
					],
					items: [
						{
							xtype: 'container',
							cls: 'top_bar',
							html: '<h4 class="header-title">Configuração inicial do OpMon 6</h4>',
							id: 'headerTitle4',
							margin: '-12 0',
							padding: '0 0 0 10',
							listeners: {
								beforerender: {
									fn: me.onHeaderTitle4BeforeRender,
									scope: me
								}
							}
						},
						{
							xtype: 'container',
							flex: 4,
							height: 36,
							id: 'sectionContainer4',
							items: [
								{
									xtype: 'toolbar',
									cls: 'top_bar',
									height: 36,
									id: 'sectionNav4',
									layout: {
										type: 'hbox',
										pack: 'center',
										padding: '5 0 0'
									},
									items: [
										{
											xtype: 'button',
											cls: 'bread-button bread-button-active',
											disabled: true,
											id: 'breadBtnStep13',
											overCls: 'none',
											allowDepress: false,
											glyph: 49,
											text: 'Definir senha do administrador',
											listeners: {
												beforerender: {
													fn: me.onBreadBtnStep13BeforeRender,
													scope: me
												}
											}
										},
										{
											xtype: 'button',
											cls: 'bread-button',
											id: 'breadBtnStep14',
											overCls: 'none',
											allowDepress: false,
											enableToggle: true,
											glyph: 50,
											text: 'Descobrir elementos da rede',
											listeners: {
												beforerender: {
													fn: me.onBreadBtnStep14BeforeRender,
													scope: me
												}
											}
										},
										{
											xtype: 'button',
											cls: 'bread-button',
											disabled: true,
											id: 'breadBtnStep15',
											overCls: 'none',
											allowDepress: false,
											glyph: 51,
											text: 'Gerar topologia',
											listeners: {
												beforerender: {
													fn: me.onBreadBtnStep15BeforeRender,
													scope: me
												}
											}
										}
									]
								}
							]
						},
						{
							xtype: 'panel',
							baseCls: 'top_bar',
							id: 'helpPanel3',
							minWidth: 60,
							headerOverCls: 'helpPanel3',
							title: '',
							tools: [
								{
									xtype: 'tool',
									handler: function(event, toolEl, owner, tool) {
										window.open(l["Knowledge Base Link"],'_blank');
									},
									type: 'help'
								}
							]
						}
					]
				},
				{
					xtype: 'panel',
					flex: 1,
					id: 'content',
					itemId: 'content',
					layout: 'border',
					header: false,
					title: 'content',
					items: [
						{
							xtype: 'panel',
							flex: 1,
							region: 'center',
							cls: 'x-container',
							id: 'rightContent',
							itemId: 'rightContent',
							collapsible: false,
							frameHeader: false,
							header: false,
							title: 'Elementos Descobertos',
							titleAlign: 'left',
							layout: {
								type: 'vbox',
								align: 'stretch'
							},
							items: [
								{
									xtype: 'components.discovery.discoverycontainer',
									itemId: 'discoveryGridContainer',
									margin: '0 0 0 0',
									flex: 1
								}
							]
						}
					]
				},
				{
					xtype: 'container',
					cls: 'top_bar',
					height: 45,
					id: 'bottomNav',
					padding: 10,
					fixed: true,
					layout: {
						type: 'hbox',
						align: 'stretch'
					},
					items: [
						{
							xtype: 'button',
							handler: function(button, event) {
								window.location.href = "/opmon/";
							},
							cls: 'button-weak-bg',
							id: 'cancelProcess',
							glyph: 215,
							text: 'Cancelar o processo e ir para o gerenciamento',
							listeners: {
								beforerender: {
									fn: me.onCancelProcessBeforeRender,
									scope: me
								}
							}
						},
						{
							xtype: 'container',
							flex: 1,
							id: 'bottomNavCancelContainer'
						},
						{
							xtype: 'button',
							handler: function(button, event) {
								Ext.getCmp('mainView').getLayout().setActiveItem('topologyView');
							},
							id: 'proceedProcess',
							text: 'Gerar topologia de rede',
							listeners: {
								beforerender: {
									fn: me.onProceedProcessBeforeRender,
									scope: me
								}
							}
						}
					]
				}
			]
		});

		me.callParent(arguments);
	},

	onHeaderTitle4BeforeRender: function(component, eOpts) {
		component.html  = "<h4 class='header-title'>";
		component.html += l["OpMon initial setup"];
		component.html += "</h4>";
	},

	onBreadBtnStep13BeforeRender: function(component, eOpts) {
		component.text = l["Set the administrator password"];
	},

	onBreadBtnStep14BeforeRender: function(component, eOpts) {
		component.text = l["Discovering network elements"];
	},

	onBreadBtnStep15BeforeRender: function(component, eOpts) {
		component.text = l["Generate network topology"];
	},

	onCancelProcessBeforeRender: function(component, eOpts) {
		component.text = l["Finish Wizard and go to OpMon"];
		//Cancelar o processo e ir para o gerenciamento
	},

	onProceedProcessBeforeRender: function(component, eOpts) {
		component.text = l["Generate network topology"];
	}

});