function edit_services_general() {

	this.hosts_being_edited = null;
	this.services_data_source;
	this.parsed_context = null;
	this.time_periods_data_source = null;
	this.servicegroups_data_source = null;
	this.uniq_services = new Array();

	this.run = function(context) {

		this.parsed_context = json_decode(context);
		if (!this.parsed_context)
			return false;

		this.time_periods_data_source = new kendo.data.DataSource({
			data: this.parsed_context.time_periods
		});
		this.servicegroups_data_source = new kendo.data.DataSource({
			data: this.parsed_context.servicegroups
		});

		this.hosts_being_edited = this.parsed_context.hosts_being_edited;
		this.prewarm_interface();
		this.assign_event_listeners();

		var post_vars = {
			url: '/opmon/seagull/www/index.php/discovery/action/servicebuckets/',
			hosts_being_edited: json_encode(this.hosts_being_edited)
		};

		do_request(post_vars, this, "create_uniq_services");

	}

	this.create_uniq_services = function(msg) {

		var service_count;
		var hosts_being_edited = null;
		var already_added_services = new Array();
		var host_services;
		var service_count;
		var svc;
		var i;
		var j;

		hosts_being_edited = json_decode(msg);
		if (!hosts_being_edited) {
			_err("edit_services_general.create_uniq_services - unable to parse json");
			return;
		}

		for(i=0; i<hosts_being_edited.length; i++) {
			host_services = hosts_being_edited[i].services;

			for(j=0; j<host_services.length; j++) {
				svc = host_services[j];
				if (already_added_services.indexOf(svc.service_description) == -1) {
					edit_services_general.uniq_services.push(svc);
				}
				already_added_services.push(svc.service_description);
			}
		}

		this.services_data_source = new kendo.observable({
			data: edit_services_general.uniq_services	
		});

		//kendo.bind(jQuery("#service-list-area"),this.uniq_services);

		jQuery(".service-checkinterval-combobox").kendoComboBox();

		service_count = 0;
		jQuery(".service-line").each(function(){
			var self = jQuery(this);
			self.attr("id","service-line-" + service_count);
			if (service_count % 2 === 0 && service_count != 0) {
				self.addClass("k-alt");
			}
			service_count += 1;
		});

		jQuery(".service-checkbox").opCheckbox();
		jQuery(".service-timeperiod-combobox").kendoComboBox({
			dataTextField: "timeperiod_name",
			dataValueField: "timeperiod_id",
			dataSource: this.time_periods_data_source	
		});
		jQuery(".service-groups-select").kendoMultiSelect({
			dataTextField: "servicegroup_name",
			dataValueField: "servicegroup_id",
			dataSource: this.servicegroups_data_source,
		});
	}

	this.prewarm_interface = function() {

		var aux;

		for(i=1; i<=100; i++) {
			aux = "<option value='"+i+"'>"+i+"</option>";
			jQuery("#service-checkinterval-select-all").append(aux);
		}

		jQuery("#service-checkbox-all").opCheckbox();

	}

	this.apply_groups_to_all_services = function() {

		jQuery(this._dataItems).each(function(){
			selected_group = this.value;
			jQuery(construct_service_list.services).each(function(){
				var count_tests = 0;
				for (var i = 0; i < this.groups.length; i += 1) {
					var count_services = this.groups.length;
					if (this.groups[i] != selected_group) { count_tests += 1; }
				}
				if (count_tests === count_services) { this.groups.push(selected_group); }
			});		
		});

	}


	this.apply_time_to_all_services = function() {
		var selected_time = parseInt(jQuery(this)[0]._selectedValue);
		jQuery(construct_service_list.services).each(function(){
			this.time = selected_time;
		});
	}

	this.assign_event_listeners = function() {

		jQuery("#service-timeperiod-select-all").kendoComboBox({
			dataTextField: "timeperiod_name",
			dataValueField: "timeperiod_id",
			dataSource: this.time_periods_data_source,
			change: edit_services_general.apply_time_to_all_services
		});
		jQuery("#service-checkinterval-select-all").kendoComboBox({
			change: edit_services_general.apply_time_to_all_services
		});
		jQuery("#service-groups-select-all").kendoMultiSelect({
			dataTextField: "servicegroup_name",
			dataValueField: "servicegroup_id",
			dataSource: this.servicegroups_data_source,
			change: edit_services_general.apply_groups_to_all_services
		});

		jQuery("#service-checkbox-all").change(function(event){
			if (event.result === true) {
				jQuery(".service-checkbox").each(function(){
					var self = jQuery(this);
					self.attr("checked", true);
					self.parent("label").addClass("check-marked");
					self.next("div").children(".k-block").addClass("k-state-selected");
				});
			} else {
				jQuery(".service-checkbox").each(function(){
					var self = jQuery(this);
					self.attr("checked", false);
					self.parent("label").removeClass("check-marked");
					self.next("div").children(".k-block").removeClass("k-state-selected");
				});
			}
		});

	}

}
