/*
 * File: app/view/WizardMainViewPort.js
 *
 * This file was generated by Sencha Architect
 * http://www.sencha.com/products/architect/
 *
 * This file requires use of the Ext JS 4.2.x library, under independent license.
 * License of Sencha Architect does not include license for Ext JS 4.2.x. For more
 * details see http://www.sencha.com/license or contact license@sencha.com.
 *
 * This file will be auto-generated each and everytime you save your project.
 *
 * Do NOT hand edit this file.
 */

Ext.define('Wizard.view.WizardMainViewPort', {
	extend: 'Ext.container.Viewport',

	id: 'WizardMainViewPort',
	layout: 'card',

	initComponent: function() {
		var me = this;

		Ext.applyIf(me, {
			listeners: {
				afterrender: {
					fn: me.onWizardMainViewPortAfterRender,
					scope: me
				}
			}
		});

		me.callParent(arguments);
	},

	onWizardMainViewPortAfterRender: function(component, eOpts) {
		Wizard.endCallBack = null;
		if (Wizard.urlData.callback) {
			Wizard.endCallBack = Wizard.urlData.callback;
		}

		/* actions */
		if (Wizard.urlData.action === undefined) {


			if (!Wizard.urlData.hosts || Wizard.urlData.hosts.length === 0) {
				showError(l.Error,l["Invalid request"]);
				return;
			}

			app = Wizard.getApplication().getEditHostsControllerController();



			for(var i = 0; i < Wizard.urlData.hosts.length; i++) {
				app.addHost(Wizard.urlData.hosts[i]);
			}

			if (! app.hostNames) {
				return null;
			}

			var errorMsg = {msg : ''};

			Ext.getStore('licenseStore').on('load', function() {

				/* show progress bar */
				makeActiveView("editServicesLoadingScreen");
				Ext.getCmp("loadingServicesProgressBar").wait({
					text: l.ObjectsLoadingMsg
				});

				var success = function(result, request) {
					requestCount--;
					var app = Wizard.getApplication().getEditHostsControllerController();
					var clearStore = false;

					try {
						app.addHostBuckets(JSON.parse(result.responseText), undefined, clearStore);
					}catch(e) {
						showError(l["Unexpected error"], e.message);
					}

					if (0 === requestCount) {
						makeActiveView("step01");
					}
				};

				var failure = function(result, request) {
					requestCount--;
					if (0 === requestCount) {
						showError(l["Unexpected error"],l["Connection Error"]);
					}
				};

				var chunckSize = 30;
				var hostNamesChunck = [];
				var requestCount = 0;

				for (var start = 0, end = chunckSize; end < (app.hostNames.length + chunckSize); start += chunckSize, end += chunckSize) {
					requestCount++;
					hostNamesChunck = app.hostNames.slice(start, end);
					Ext.Ajax.request({
						url: '/opmon/seagull/www/index.php/discovery/action/hostbuckets/',
						method: "POST",
						params: {
							hosts_being_edited: JSON.stringify(hostNamesChunck),
							use_host_from_discovery: ((Wizard.urlData.from) ? 1 : 0)
						},
						success: success,
						failure: failure
					});
				}
			});
			return;
		}



		if (Wizard.urlData.action == 'editServices') {
			app = Wizard.getApplication().getEditHostsControllerController();
			app.getEditableServices();
			return;
		}

		if (Wizard.urlData.action == 'addHost') {
			makeActiveView("step01");
			app = Wizard.getApplication().getEditHostsControllerController();
			app.getHostDiscoveryStoreStore().load();
			w = Ext.create("Wizard.view.selectHostOrigin");
			w.show();
			return;
		}

		if (Wizard.urlData.action == 'addService') {
			makeActiveView("editServices");
			w = Ext.create("Wizard.view.addNewService");
			w.show();
			return;
		}

		if (Wizard.urlData.action == 'cloneHost') {
			w = Ext.create("Wizard.view.duplicateHost");
			w.show();
			return;
		}

		if (Wizard.urlData.action == 'cloneService') {

			Ext.Ajax.request({
				url: '/opmon/seagull/www/index.php/discovery/action/servicebuckets/',
				method: "POST",
				params: {
					services_being_edited: JSON.stringify(Wizard.urlData.services)
				},
				success: function(result, request) {
					var obj;

					makeActiveView("duplicateService");
					w = Ext.getCmp("duplicateService");

					obj = JSON.parse(result.responseText);
					if (!obj) {
						showError(l["Unexpected error"], l["Connection Error"]);
						return;
					}

					if (obj.success === false) {
						w.removeAll();
						Ext.getCmp("cloneServiceConfirmButton").disable();
						lbl = Ext.create("Ext.form.Label");
						lbl.text = obj.message;
						w.add(lbl);
					} else {
						w.setBuckets(obj.services);
					}

				},
				failure: function(result, request) {
					showError(l["Unexpected error"],l["Connection Error"]);
				}

			});

		}

		if (Wizard.urlData.action == 'deleteHosts') {
			w = Ext.create("Wizard.view.removeHost");
			w.show();
			return;
		}

		if (Wizard.urlData.action == 'deleteServices') {
			w = Ext.create("Wizard.view.removeService");
			w.show();
			return;
		}

	}

});