/*
 * File: app/view/addNewService.js
 *
 * This file was generated by Sencha Architect
 * http://www.sencha.com/products/architect/
 *
 * This file requires use of the Ext JS 4.2.x library, under independent license.
 * License of Sencha Architect does not include license for Ext JS 4.2.x. For more
 * details see http://www.sencha.com/license or contact license@sencha.com.
 *
 * This file will be auto-generated each and everytime you save your project.
 *
 * Do NOT hand edit this file.
 */

Ext.define('Wizard.view.addNewService', {
	extend: 'Ext.window.Window',

	requires: [
		'Ext.form.Panel',
		'Ext.form.field.ComboBox',
		'Ext.form.field.Number',
		'Ext.toolbar.Toolbar',
		'Ext.button.Button',
		'Ext.toolbar.Spacer'
	],

	draggable: false,
	height: 255,
	id: 'newService1',
	width: 400,
	closable: false,
	title: 'Definir os parâmetros do serviço',
	modal: true,

	initComponent: function() {
		var me = this;

		Ext.applyIf(me, {
			items: [
				{
					xtype: 'form',
					id: 'serviceParamsPanel4',
					bodyPadding: 20,
					header: false,
					title: 'Definir os parâmetros do serviço',
					layout: {
						type: 'vbox',
						align: 'stretch'
					},
					items: [
						{
							xtype: 'combobox',
							flex: 1,
							id: 'newServiceHostName',
							fieldLabel: 'Hosts alvo',
							labelSeparator: ' ',
							labelWidth: 140,
							allowBlank: false,
							allowOnlyWhitespace: false,
							blankText: Ext.locale.translate('This field is mandatory'),
							anyMatch: true,
							displayField: 'host_name',
							forceSelection: true,
							multiSelect: true,
							queryMode: 'local',
							store: 'Hosts',
							valueField: 'host_id',
							listeners: {
								beforerender: {
									fn: me.onNewServiceHostNameBeforeRender,
									scope: me
								},
								change: {
									fn: me.onNewServiceHostNameChange,
									scope: me
								}
							}
						},
						{
							xtype: 'textfield',
							id: 'newServiceServiceDescription1',
							fieldLabel: 'Nome do serviço',
							labelSeparator: ' ',
							labelWidth: 140,
							allowBlank: false,
							allowOnlyWhitespace: false,
							blankText: Ext.locale.translate('This field is mandatory'),
							listeners: {
								beforerender: {
									fn: me.onNewServiceServiceDescription1BeforeRender,
									scope: me
								},
								blur: {
									fn: me.onNewServiceServiceDescription1Blur,
									scope: me
								}
							}
						},
						{
							xtype: 'numberfield',
							id: 'newServiceCheckInterval1',
							fieldLabel: 'Intervalo de checagem',
							labelSeparator: ' ',
							labelWidth: 140,
							value: 5,
							minText: ''+Ext.locale.translate('Min')+'. 1',
							minValue: 1,
							listeners: {
								beforerender: {
									fn: me.onNewServiceCheckInterval1BeforeRender,
									scope: me
								}
							}
						},
						{
							xtype: 'combobox',
							id: 'newServiceCheckPeriod1',
							fieldLabel: 'Período de checagem',
							labelSeparator: ' ',
							labelWidth: 140,
							allowBlank: false,
							allowOnlyWhitespace: false,
							blankText: Ext.locale.translate('This field is mandatory'),
							anyMatch: true,
							displayField: 'timeperiod_name',
							forceSelection: true,
							queryMode: 'local',
							store: 'timePeriodStore',
							valueField: 'timeperiod_id',
							listeners: {
								beforerender: {
									fn: me.onNewServiceCheckPeriod1BeforeRender,
									scope: me
								}
							}
						},
						{
							xtype: 'combobox',
							id: 'newServiceServiceGroups1',
							fieldLabel: 'Grupos de serviços',
							labelSeparator: ' ',
							labelWidth: 140,
							anyMatch: true,
							displayField: 'servicegroup_name',
							forceSelection: true,
							multiSelect: true,
							queryMode: 'local',
							store: 'serviceGroupStore',
							valueField: 'servicegroup_id',
							listeners: {
								beforerender: {
									fn: me.onNewServiceServiceGroups1BeforeRender,
									scope: me
								}
							}
						}
					],
					listeners: {
						validitychange: {
							fn: me.onServiceParamsPanel4ValidityChange,
							scope: me
						}
					}
				}
			],
			dockedItems: [
				{
					xtype: 'toolbar',
					dock: 'bottom',
					baseCls: 'x-toolbar-footer',
					id: 'navBar16',
					items: [
						{
							xtype: 'button',
							handler: function(button, event) {
								if (Wizard.endCallBack) {
									func = "parent."+Wizard.endCallBack+"(false);";
									eval(func);
								}

							},
							id: 'prevBtn15',
							text: 'Cancelar',
							listeners: {
								beforerender: {
									fn: me.onPrevBtn15BeforeRender,
									scope: me
								}
							}
						},
						{
							xtype: 'tbspacer',
							flex: 1
						},
						{
							xtype: 'container',
							items: [
								{
									xtype: 'button',
									handler: function(button, event) {
										me = Ext.getCmp("newService1");

										if (me.validateForm() === false) {
											return;
										}

										Ext.Ajax.request({
											url: '/opmon/seagull/www/index.php/discovery/action/get_service_bucket/',
											method: 'GET',
											success: function(result, request) {
												var bucket;
												var hostStore;

												try {
													bucket = JSON.parse(result.responseText);
												} catch(err) {
													showError("Error",err.message);
													return;
												}

												hostStore = Wizard.getApplication().getAlreadyMonitoredHostStoreStore();

												var services = [];
												var selectedHosts = Ext.getCmp("newServiceHostName").getValue();
												var errorMsg = {msg : ''};
												if (! isLicensed("service", selectedHosts.length, errorMsg)) {
													showError(t("License limit reached"), errorMsg.msg);
													return;
												}

												for(i=0; i<selectedHosts.length; i++) {

													pos = hostStore.find("host_id",selectedHosts[i]);
													if (pos < 0)
													continue;

													host = hostStore.getAt(pos);

													bucketCopy = Ext.clone(bucket);
													bucketCopy.host_id = selectedHosts[i];
													bucketCopy.host_name = host.get("host_name");
													bucketCopy.service_description = Ext.getCmp("newServiceServiceDescription1").getValue();
													bucketCopy.original_service_description = Ext.getCmp("newServiceServiceDescription1").getValue();
													bucketCopy.normal_check_interval = Ext.getCmp("newServiceCheckInterval1").getValue();
													bucketCopy.check_period = Ext.getCmp("newServiceCheckPeriod1").getValue();
													bucketCopy.servicegroups = Ext.getCmp("newServiceServiceGroups1").getValue();
													services.push(bucketCopy);
												}

												if (services.length < 1)
												return;

												var w = Ext.create("Wizard.view.selectCommand");
												w.addServiceBucket(Ext.clone(services[0]));
												w.setCallBack(function(update, updatedservice) {
													var i;

													for(i in services) {
														services[i].check_command = updatedservice.check_command;
														services[i].original_check_command = updatedservice.check_command;
														services[i].check_parameters = updatedservice.check_parameters;
														services[i].contactgroups = window.new_service_contactgroups;
														services[i].contacts = window.new_service_contacts;
													}

													var app = Wizard.getApplication().getEditHostsControllerController();
													var svcWindow = Ext.getCmp('editServices');
													svcWindow.allServicesBeingEdited = services;
													svcWindow.groupedServices = app.preProcessServices(services);
												});
												w.show();

											},
											failure: function(result, request) {
												showError(l.Error, result.responseText);
											}
										});
									},
									disabled: true,
									id: 'nextBtn16',
									text: 'Criar serviço',
									listeners: {
										beforerender: {
											fn: me.onNextBtn16BeforeRender,
											scope: me
										}
									}
								}
							]
						}
					]
				}
			],
			listeners: {
				beforerender: {
					fn: me.onNewService1BeforeRender,
					scope: me
				}
			}
		});

		me.callParent(arguments);
	},

	onNewServiceHostNameBeforeRender: function(component, eOpts) {
		component.fieldLabel = l["Target hosts"];
	},

	onNewServiceHostNameChange: function(field, newValue, oldValue, eOpts) {
		var contactgroups = [];
		var contacts = [];
		var store = Ext.getStore("alreadyMonitoredHostStore");

		for (var i=0; i < newValue.length; i++) {

			var record = store.data.getByKey(newValue[i]);

			var record_contactgroups = record.get("contactgroups");
			for (var j=0; j < record_contactgroups.length; j++) {
				contactgroups.push(record_contactgroups[j]);
			}

			var record_contacts = record.get("contacts");
			for (var k=0; k < record_contacts.length; k++) {
				contacts.push(record_contacts[k]);
			}

		}

		contactgroups = contactgroups.filter(function(elem, index, self) {
			return index == self.indexOf(elem);
		});

		contacts = contacts.filter(function(elem, index, self) {
			return index == self.indexOf(elem);
		});

		window.new_service_contactgroups = contactgroups;
		window.new_service_contacts = contacts;
	},

	onNewServiceServiceDescription1BeforeRender: function(component, eOpts) {
		component.fieldLabel = l["Service Name"];
	},

	onNewServiceServiceDescription1Blur: function(component, e, eOpts) {
		component.setValue(
			changeCharCode(component.getValue())
		);
	},

	onNewServiceCheckInterval1BeforeRender: function(component, eOpts) {
		component.fieldLabel = l["Check Interval"];
	},

	onNewServiceCheckPeriod1BeforeRender: function(component, eOpts) {
		component.fieldLabel = l["Period"];
	},

	onNewServiceServiceGroups1BeforeRender: function(component, eOpts) {
		component.fieldLabel = l["Service Groups"];
	},

	onServiceParamsPanel4ValidityChange: function(basic, valid, eOpts) {
		if(this.validateForm()) {
			return Ext.getCmp('nextBtn16').enable();
		}
		Ext.getCmp('nextBtn16').disable();
	},

	onPrevBtn15BeforeRender: function(component, eOpts) {
		component.text = l["Back"];
	},

	onNextBtn16BeforeRender: function(component, eOpts) {
		component.text = l["Next"];
	},

	onNewService1BeforeRender: function(component, eOpts) {
		component.title = l["Create service"];
	},

	updateFormValues: function() {
		svc = Wizard.newServiceBucket;
		Ext.getCmp("newServiceServiceDescription").setValue(svc.get("service_description"));
		Ext.getCmp("newServiceCheckInterval").setValue(svc.get("normal_check_interval"));
		Ext.getCmp("newServiceCheckPeriod").setValue(svc.get("check_period").toString());
		Ext.getCmp("newServiceServiceGroups").setValue(svc.get("servicegroups"));
	},

	validateForm: function() {
		if (!Ext.getCmp("newServiceHostName").getValue() || Ext.getCmp("newServiceHostName").getValue().length == 0) {
			//showError(l["Error"],l["You must select at least one host"]);
			return false;
		}

		if (Ext.getCmp("newServiceServiceDescription1").getValue() == "") {
			//showError(l["Error"],l["Service description invalid"]);
			return false;
		}

		if (Ext.getCmp("newServiceCheckPeriod1").getValue() === null) {
			//showError(l["Error"],l["Period check invalid"]);
			return false;
		}

		if (Ext.getCmp("newServiceCheckPeriod1").getValue() === null) {
			//showError(l["Error"],l["Period check invalid"]);
			return false;
		}

		if(Ext.getCmp("newServiceCheckInterval1").getValue() === null || Ext.getCmp("newServiceCheckInterval1").getValue() < 1) {
			return false;
		}

		return true;
	}

});