/*
 * File: app/view/duplicateHost.js
 *
 * This file was generated by Sencha Architect
 * http://www.sencha.com/products/architect/
 *
 * This file requires use of the Ext JS 4.2.x library, under independent license.
 * License of Sencha Architect does not include license for Ext JS 4.2.x. For more
 * details see http://www.sencha.com/license or contact license@sencha.com.
 *
 * This file will be auto-generated each and everytime you save your project.
 *
 * Do NOT hand edit this file.
 */

Ext.define('Wizard.view.duplicateHost', {
	extend: 'Ext.window.Window',

	requires: [
		'Ext.form.Panel',
		'Ext.form.field.Text',
		'Ext.toolbar.Toolbar',
		'Ext.toolbar.Spacer',
		'Ext.button.Button'
	],

	height: 165,
	id: 'duplicatHost',
	width: 400,
	header: false,
	title: 'Duplicar o host',

	initComponent: function() {
		var me = this;

		Ext.applyIf(me, {
			items: [
				{
					xtype: 'form',
					id: 'serviceParamsPanel1',
					bodyPadding: 20,
					header: false,
					title: 'Definir os parâmetros do serviço',
					layout: {
						type: 'vbox',
						align: 'stretch'
					},
					items: [
						{
							xtype: 'textfield',
							id: 'newHostHostName',
							fieldLabel: 'Defina o nome do host',
							labelSeparator: ' ',
							labelWidth: 140,
							listeners: {
								blur: {
									fn: me.onNewHostHostNameBlur,
									scope: me
								},
								beforerender: {
									fn: me.onNewHostHostNameBeforeRender,
									scope: me
								}
							}
						},
						{
							xtype: 'textfield',
							id: 'newHostAddress',
							fieldLabel: 'Defina o IP do host',
							labelSeparator: ' ',
							labelWidth: 140,
							listeners: {
								beforerender: {
									fn: me.onNewHostAddressBeforeRender,
									scope: me
								}
							}
						},
						{
							xtype: 'textfield',
							id: 'newHostAlias',
							fieldLabel: 'Defina a descrição',
							labelSeparator: ' ',
							labelWidth: 140,
							listeners: {
								beforerender: {
									fn: me.onNewHostAliasBeforeRender,
									scope: me
								}
							}
						}
					]
				}
			],
			dockedItems: [
				{
					xtype: 'toolbar',
					dock: 'bottom',
					baseCls: 'x-toolbar-footer',
					id: 'navBar10',
					items: [
						{
							xtype: 'tbspacer',
							flex: 1
						},
						{
							xtype: 'container',
							items: [
								{
									xtype: 'button',
									handler: function(button, event) {
										var hostName;
										var hostAddress;
										var hostAlias;

										hostName = Ext.getCmp('newHostHostName').getValue();
										hostAddress = Ext.getCmp('newHostAddress').getValue();
										hostAlias = Ext.getCmp('newHostAlias').getValue();

										if (hostName === "") {
											showError(l.Error, l["Invalid hostname"]);
											return;
										}

										if (hostAddress === "") {
											showError(l.Error, l["Invalid IP"]);
											return;
										}

										var errorMsg = {msg : ''};
										if (! isLicensed("host", 1, errorMsg)) {
											showError(t("License limit reached"), errorMsg.msg);
											return;
										}

										Ext.Ajax.request({
											url: '/opmon/seagull/www/index.php/discovery/action/hostbuckets/',
											timeout: 60000,
											method: 'POST',
											params: {
												hosts_being_edited: JSON.stringify([Wizard.urlData.hostName])
											},
											success: function(result,request) {
												var originalHost;
												var i;

												originalHost = JSON.parse(result.responseText)[0];
												originalHost.host_id = null;
												originalHost.already_monitored = false;
												originalHost.host_name = hostName;
												originalHost.original_host_name = hostName;
												originalHost.alias = hostAlias;
												originalHost.address = hostAddress;

												for(i=0; i<originalHost.services.length; i++) {
													originalHost.services[i].host_id = null;
													originalHost.services[i].service_id = null;
													originalHost.services[i].already_monitored = false;
												}



												Ext.Ajax.request({
													url: '/opmon/seagull/www/index.php/discovery/action/discovery_jobs/operation/import_objects/',
													method: 'POST',
													params: {
														data: JSON.stringify([originalHost])
													},
													success: function(result, request) {
														obj = JSON.parse(result.responseText);

														if (!obj) {
															showError(l["Unexpected error"],l["JSON not found"]);
															return;
														}

														if (!obj.success) {
															showError(l["Unexpected error"], obj.message);
															return;
														}

														if (Wizard.endCallBack) {
															func = "parent."+Wizard.endCallBack+"(true);";
															eval(func);
														}

													},
													failure: function(object, request) {
														showError(l["Error"],l["Error"], object);
													}

												});
											},
											failure: function(result,request) {
												showError(l["Error"],result.responseText);
											}
										});

									},
									id: 'nextBtn10',
									text: 'Avançar',
									listeners: {
										beforerender: {
											fn: me.onNextBtn10BeforeRender,
											scope: me
										}
									}
								}
							]
						}
					]
				}
			],
			listeners: {
				beforerender: {
					fn: me.onDuplicatHostBeforeRender,
					scope: me
				}
			}
		});

		me.callParent(arguments);
	},

	onNewHostHostNameBlur: function(component, e, eOpts) {
		component.setValue(
		changeCharCode(component.getValue())
		);
	},

	onNewHostHostNameBeforeRender: function(component, eOpts) {
		component.fieldLabel = l["Set the hostname"];
	},

	onNewHostAddressBeforeRender: function(component, eOpts) {
		component.fieldLabel = l["Set the host IP"];
	},

	onNewHostAliasBeforeRender: function(component, eOpts) {
		component.fieldLabel = l["Set the description"];
	},

	onNextBtn10BeforeRender: function(component, eOpts) {
		component.text = l["Save"];
	},

	onDuplicatHostBeforeRender: function(component, eOpts) {
		component.title = l["Duplicate host"];
	}

});