/*
 * File: app/view/duplicateService.js
 *
 * This file was generated by Sencha Architect
 * http://www.sencha.com/products/architect/
 *
 * This file requires use of the Ext JS 4.2.x library, under independent license.
 * License of Sencha Architect does not include license for Ext JS 4.2.x. For more
 * details see http://www.sencha.com/license or contact license@sencha.com.
 *
 * This file will be auto-generated each and everytime you save your project.
 *
 * Do NOT hand edit this file.
 */

Ext.define('Wizard.view.duplicateService', {
	extend: 'Ext.panel.Panel',
	alias: 'widget.duplicateservice',

	requires: [
		'Ext.form.Panel',
		'Ext.form.field.ComboBox',
		'Ext.toolbar.Toolbar',
		'Ext.button.Button',
		'Ext.toolbar.Spacer'
	],

	height: 110,
	id: 'duplicateService',
	width: 400,
	header: false,
	title: 'Selecione os hosts que receberão o serviço',

	initComponent: function() {
		var me = this;

		Ext.applyIf(me, {
			items: [
				{
					xtype: 'form',
					id: 'serviceParamsPanel5',
					bodyPadding: 20,
					header: false,
					title: 'Definir os parâmetros do serviço',
					layout: {
						type: 'vbox',
						align: 'stretch'
					},
					items: [
						{
							xtype: 'combobox',
							flex: 1,
							id: 'newServiceHostName1',
							fieldLabel: 'Hosts alvo',
							labelSeparator: ' ',
							labelWidth: 70,
							displayField: 'host_name',
							forceSelection: true,
							multiSelect: true,
							queryMode: 'local',
							store: 'Hosts',
							valueField: 'host_id',
							listeners: {
								beforerender: {
									fn: me.onNewServiceHostName1BeforeRender,
									scope: me
								}
							}
						}
					]
				}
			],
			dockedItems: [
				{
					xtype: 'toolbar',
					dock: 'bottom',
					baseCls: 'x-toolbar-footer',
					id: 'navBar17',
					items: [
						{
							xtype: 'button',
							handler: function(button, event) {
								if (Wizard.endCallBack) {
									func = "parent."+Wizard.endCallBack+"(false);";
									eval(func);
								}

							},
							id: 'prevBtn16',
							text: 'Cancelar',
							listeners: {
								beforerender: {
									fn: me.onPrevBtn16BeforeRender,
									scope: me
								}
							}
						},
						{
							xtype: 'tbspacer',
							flex: 1
						},
						{
							xtype: 'container',
							items: [
								{
									xtype: 'button',
									handler: function(button, event) {
										me = Ext.getCmp("duplicateService");

										if (me.validateForm() === false) {
											return;
										}

										if(Wizard.clone) {
											me.setBuckets(Ext.getStore('serviceStore').data.items.map(function(item) {
												return item.data;
											}));
										}
										services = me.prepareServices();

										var errorMsg = {msg : ''};
										if (! isLicensed("service", selHosts.length * me.buckets.length, errorMsg)) {
											showError(t("License limit reached"), errorMsg.msg);
											return ;
										}


										Ext.Ajax.request({
											url: '/opmon/seagull/www/index.php/discovery/action/saveservices/',
											method: 'POST',
											params: {
												services: JSON.stringify(services)
											},
											success: function(result, request) {

												var obj;
												obj = JSON.parse(result.responseText);
												if (!obj) {
													showError(l["Unexpected error"],l["JSON not found"]);
													return;
												}
												if (!obj.success) {
													showError(l["Unexpected error"], obj.message);
													return;
												}
												if (Wizard.endCallBack) {
													func = "parent."+Wizard.endCallBack+"(true);";
													eval(func);
												}

											},
											failure: function(object, request) {
												showError(l.Error,l.Error, object);
											}

										});
									},
									id: 'cloneServiceConfirmButton',
									text: 'Aplicar serviço aos hosts',
									listeners: {
										beforerender: {
											fn: me.onCloneServiceConfirmButtonBeforeRender,
											scope: me
										}
									}
								}
							]
						},
						{
							xtype: 'button',
							handler: function(button, e) {
								var app = Wizard.getApplication().getEditHostsControllerController();
								var tmp = Wizard.endCallBack;

								Wizard.clone = true;
								app.getEditableServices();

								Wizard.endCallBack = function() {
									makeActiveView("duplicateService");
									Wizard.endCallBack = tmp;
								};

							},
							text: 'Editar antes de duplicar',
							listeners: {
								beforerender: {
									fn: me.onButtonBeforeRender,
									scope: me
								}
							}
						}
					]
				}
			],
			listeners: {
				beforerender: {
					fn: me.onNewService2BeforeRender,
					scope: me
				}
			}
		});

		me.callParent(arguments);
	},

	onNewServiceHostName1BeforeRender: function(component, eOpts) {
		component.fieldLabel = l["Target hosts"];
	},

	onPrevBtn16BeforeRender: function(component, eOpts) {
		component.text = l["Cancel"];
	},

	onCloneServiceConfirmButtonBeforeRender: function(component, eOpts) {
		component.text = l["Apply service to hosts"];
	},

	onButtonBeforeRender: function(component, eOpts) {
		component.text = t("Edit before duplicating");
	},

	onNewService2BeforeRender: function(component, eOpts) {
		component.title = l["Select the hosts that receive the service"];
	},

	validateForm: function() {
		if (! Ext.getCmp("newServiceHostName1").getValue()
			   || Ext.getCmp("newServiceHostName1").getValue().length === 0) {
			showError(l["Error"],l["You must select at least one host"]);
			return false;
		}

		return true;
	},

	setBuckets: function(buckets) {
		me = Ext.getCmp("duplicateService");
		me.buckets = buckets;
	},

	prepareServices: function() {
		services = [];
		me = Ext.getCmp("duplicateService");

		hosts = Wizard.getApplication().getHostsStore();
		selHosts = Ext.getCmp("newServiceHostName1").getValue();

		for(i=0; i<selHosts.length; i++) {

			host = hosts.getById(selHosts[i]);
			if (!host) {
				continue;
			}

			for(j=0; j<me.buckets.length; j++) {

				copy = Ext.clone(me.buckets[j]);
				copy.original_host_id = copy.host_id;
				copy.original_service_id = copy.service_id;
				copy.service_id = null;
				copy.host_id = host.get("host_id");
				copy.host_name = host.get("host_name");
				copy.already_monitored = false;
				copy.selected = true;
				services.push(copy);

			}


		}

		return services;
	}

});