/*
 * File: app/view/editGroupsPanel.js
 *
 * This file was generated by Sencha Architect
 * http://www.sencha.com/products/architect/
 *
 * This file requires use of the Ext JS 4.2.x library, under independent license.
 * License of Sencha Architect does not include license for Ext JS 4.2.x. For more
 * details see http://www.sencha.com/license or contact license@sencha.com.
 *
 * This file will be auto-generated each and everytime you save your project.
 *
 * Do NOT hand edit this file.
 */

Ext.define('Wizard.view.editGroupsPanel', {
	extend: 'Ext.panel.Panel',
	alias: 'widget.editgroupspanel',

	requires: [
		'Ext.tree.Panel',
		'Ext.tree.View',
		'Ext.tree.plugin.TreeViewDragDrop',
		'Ext.form.Panel',
		'Ext.form.Label',
		'Ext.form.field.TextArea',
		'Ext.button.Button',
		'Ext.form.field.ComboBox',
		'Ext.toolbar.Toolbar',
		'Ext.toolbar.Spacer'
	],

	height: 500,
	id: 'editGroupsPanel',
	width: 800,
	header: false,
	title: 'Editar Grupos de Hosts',

	layout: {
		type: 'vbox',
		align: 'stretch'
	},

	initComponent: function() {
		var me = this;

		Ext.applyIf(me, {
			items: [
				{
					xtype: 'container',
					flex: 1,
					id: 'treesContainers',
					layout: {
						type: 'hbox',
						align: 'stretch'
					},
					items: [
						{
							xtype: 'panel',
							flex: 1,
							id: 'hostPanel',
							padding: '0 2 0 0',
							bodyPadding: 5,
							title: 'Grupos de Hosts',
							layout: {
								type: 'hbox',
								align: 'stretch'
							},
							items: [
								{
									xtype: 'container',
									flex: 1,
									layout: {
										type: 'hbox',
										align: 'stretch'
									},
									items: [
										{
											xtype: 'treepanel',
											flex: 1,
											autoRender: true,
											id: 'hostGroupsTreePanel',
											maxWidth: 180,
											minWidth: 180,
											header: false,
											title: 'My Tree Panel',
											hideHeaders: true,
											store: 'hostGroupTreeStore',
											displayField: 'hostgroup_name',
											rootVisible: false,
											viewConfig: {
												id: 'hostGroupsTreeview',
												plugins: [
													Ext.create('Ext.tree.plugin.TreeViewDragDrop', {
														allowParentInserts: true,
														appendOnly: true
													})
												],
												listeners: {
													itemclick: {
														fn: me.onHostGroupsTreeviewItemClick,
														scope: me
													}
												}
											},
											listeners: {
												beforeitemmove: {
													fn: me.onHostGroupsTreePanelBeforeItemMove,
													scope: me
												}
											}
										},
										{
											xtype: 'panel',
											flex: 5,
											id: 'editHostPanel',
											layout: 'card',
											header: false,
											title: 'My Panel',
											items: [
												{
													xtype: 'form',
													id: 'newHostGroup',
													maxHeight: 250,
													bodyPadding: 10,
													header: false,
													title: 'My Form',
													layout: {
														type: 'vbox',
														align: 'stretch'
													},
													items: [
														{
															xtype: 'label',
															cls: 'bold',
															height: 30,
															text: 'Criar grupo de hosts',
															listeners: {
																beforerender: {
																	fn: me.onLabelBeforeRender,
																	scope: me
																}
															}
														},
														{
															xtype: 'textfield',
															id: 'newHostGroupName',
															fieldLabel: 'Nome',
															labelSeparator: ' ',
															labelWidth: 60,
															enableKeyEvents: true,
															listeners: {
																blur: {
																	fn: me.onNewHostGroupNameBlur,
																	scope: me
																},
																beforerender: {
																	fn: me.onNewHostGroupNameBeforeRender,
																	scope: me
																}
															}
														},
														{
															xtype: 'textareafield',
															id: 'newHostGroupAlias',
															fieldLabel: 'Descrição',
															labelSeparator: ' ',
															labelWidth: 60,
															listeners: {
																beforerender: {
																	fn: me.onNewHostGroupAliasBeforeRender,
																	scope: me
																}
															}
														},
														{
															xtype: 'container',
															flex: 1,
															id: 'newGroupNav',
															margin: '10 0 0',
															maxHeight: 26,
															layout: {
																type: 'hbox',
																align: 'stretch'
															},
															items: [
																{
																	xtype: 'container',
																	flex: 1
																},
																{
																	xtype: 'button',
																	handler: function(button, event) {
																		var h;
																		var hostgroupStore;
																		var afterSync;
																		var exists;

																		hostgroupStore = Wizard.getApplication().getHostGroupStoreStore();
																		if (Ext.getCmp('newHostGroupName').getValue() == "") {
																			showInfo(l["Information"],l["Invalid group name"]);
																			return;
																		}

																		exists = hostgroupStore.find("hostgroup_name", Ext.getCmp('newHostGroupName').getValue());
																		if (exists >= 0) {
																			showInfo(l["Information"],Ext.getCmp('newHostGroupName').getValue() + " "+ l["Already exists"]);
																			return;
																		}

																		h = {
																			network_id: 0,
																			hostgroup_name: Ext.getCmp('newHostGroupName').getValue(),
																			alias: Ext.getCmp('newHostGroupAlias').getValue(),
																			in_map: 1,
																			members: []
																		};
																		hostgroupStore.add(h);

																		afterSync = {

																			success: function(batch, options) {

																				h = Ext.clone(getHostGroupByName(Ext.getCmp('newHostGroupName').getValue()));
																				treeStore = Ext.getCmp('hostGroupsTreePanel').getStore();

																				node = treeStore.getRootNode();
																				node.appendChild(h);

																				Ext.getCmp('newHostGroupName').setValue("");
																				Ext.getCmp('newHostGroupAlias').setValue("");

																			},
																			failure: function(batch, options) {
																				showError( l["Storage error"], l["Unable to synchronize group of hosts"],batch);
																			}
																		}

																		hostgroupStore.sync(afterSync);
																	},
																	flex: 1,
																	id: 'saveNewHostGroup',
																	text: 'Salvar',
																	listeners: {
																		beforerender: {
																			fn: me.onSaveNewHostGroupBeforeRender,
																			scope: me
																		}
																	}
																}
															]
														}
													]
												},
												{
													xtype: 'panel',
													id: 'optionsHostPanel',
													bodyPadding: '20 10 0',
													header: false,
													title: 'My Panel',
													layout: {
														type: 'vbox',
														align: 'stretch'
													},
													items: [
														{
															xtype: 'form',
															flex: 1,
															id: 'addHostToGroup',
															bodyPadding: 10,
															header: false,
															title: 'My Form',
															items: [
																{
																	xtype: 'label',
																	text: 'Adicionar hosts a grupo'
																},
																{
																	xtype: 'combobox',
																	anchor: '100%',
																	id: 'addHostHostgroupHostgroup',
																	fieldLabel: 'Label',
																	hideLabel: true,
																	emptyText: 'Selecione o grupo',
																	displayField: 'hostgroup_name',
																	queryMode: 'local',
																	store: 'hostGroupStore',
																	valueField: 'hostgroup_id'
																},
																{
																	xtype: 'combobox',
																	anchor: '100%',
																	id: 'addHostHostgroupHosts',
																	fieldLabel: 'Label',
																	hideLabel: true,
																	emptyText: 'Selecione os hosts',
																	displayField: 'host_name',
																	multiSelect: true,
																	queryCaching: false,
																	queryMode: 'local',
																	store: 'alreadyMonitoredHostStore',
																	valueField: 'host_id'
																},
																{
																	xtype: 'button',
																	id: 'applyHostGroup',
																	text: 'Aplicar',
																	listeners: {
																		click: {
																			fn: me.onApplyHostGroupClick,
																			scope: me
																		}
																	}
																}
															]
														},
														{
															xtype: 'button',
															handler: function(button, event) {
																Ext.getCmp('editHostPanel').getLayout().setActiveItem('newHostGroup');
															},
															id: 'newHostGroupBtn',
															margin: '0 0 10 0',
															glyph: 43,
															text: 'Novo grupo de host'
														}
													]
												}
											]
										}
									]
								}
							],
							listeners: {
								beforerender: {
									fn: me.onHostPanelBeforeRender,
									scope: me
								}
							}
						},
						{
							xtype: 'panel',
							flex: 1,
							id: 'servicePanel',
							padding: '0 0 0 3',
							bodyPadding: 5,
							title: 'Grupos de Serviços',
							layout: {
								type: 'hbox',
								align: 'stretch'
							},
							items: [
								{
									xtype: 'container',
									flex: 1,
									layout: {
										type: 'hbox',
										align: 'stretch'
									},
									items: [
										{
											xtype: 'treepanel',
											flex: 1,
											id: 'serviceGroupsTreePanel',
											maxWidth: 180,
											minWidth: 180,
											header: false,
											title: 'serviceGroupsTreePanel',
											hideHeaders: true,
											store: 'serviceGroupTreeStore',
											displayField: 'servicegroup_name',
											rootVisible: false,
											viewConfig: {
												plugins: [
													Ext.create('Ext.tree.plugin.TreeViewDragDrop', {
														appendOnly: true
													})
												],
												listeners: {
													itemclick: {
														fn: me.onViewItemClick,
														scope: me
													}
												}
											},
											listeners: {
												beforeitemmove: {
													fn: me.onServiceGroupsTreePanelBeforeItemMove,
													scope: me
												}
											}
										},
										{
											xtype: 'panel',
											flex: 5,
											id: 'editServicePanel',
											layout: 'card',
											header: false,
											title: 'My Panel',
											items: [
												{
													xtype: 'form',
													id: 'newServiceGroup',
													bodyPadding: 10,
													header: false,
													title: 'My Form',
													layout: {
														type: 'vbox',
														align: 'stretch'
													},
													items: [
														{
															xtype: 'label',
															cls: 'bold',
															height: 30,
															text: 'Criar grupo de serviços',
															listeners: {
																beforerender: {
																	fn: me.onLabelBeforeRender1,
																	scope: me
																}
															}
														},
														{
															xtype: 'textfield',
															id: 'newServiceGroupName',
															fieldLabel: 'Nome',
															labelSeparator: ' ',
															labelWidth: 60,
															enableKeyEvents: true,
															listeners: {
																blur: {
																	fn: me.onNewServiceGroupNameBlur,
																	scope: me
																},
																beforerender: {
																	fn: me.onNewServiceGroupNameBeforeRender,
																	scope: me
																}
															}
														},
														{
															xtype: 'textareafield',
															id: 'newServiceGroupAlias',
															fieldLabel: 'Descrição',
															labelSeparator: ' ',
															labelWidth: 60,
															listeners: {
																beforerender: {
																	fn: me.onNewServiceGroupAliasBeforeRender,
																	scope: me
																}
															}
														},
														{
															xtype: 'container',
															flex: 1,
															id: 'newGroupNav1',
															margin: '10 0 0',
															maxHeight: 26,
															layout: {
																type: 'hbox',
																align: 'stretch'
															},
															items: [
																{
																	xtype: 'container',
																	flex: 1
																},
																{
																	xtype: 'button',
																	handler: function(button, event) {
																		var h;
																		var serviceGroup;
																		var afterSync;
																		var exists;

																		servicegroupStore = Wizard.getApplication().getServiceGroupStoreStore();
																		if (Ext.getCmp('newServiceGroupName').getValue() == "") {
																			showInfo( l["Information"],l["Invalid group name"]);
																			return;
																		}

																		exists = servicegroupStore.find("servicegroup_name", Ext.getCmp('newServiceGroupName').getValue());
																		if (exists >= 0) {
																			showInfo( l["Information"], Ext.getCmp('newServiceGroupName').getValue() + " "+ l["Already exists"]);
																			return;
																		}


																		h = {
																			servicegroup_name: Ext.getCmp('newServiceGroupName').getValue(),
																			alias: Ext.getCmp('newServiceGroupAlias').getValue(),
																			in_map: 1,
																			members: []
																		};
																		servicegroupStore.add(h);

																		afterSync = {

																			success: function(batch, options) {
																				h = Ext.clone(getServiceGroupByName(Ext.getCmp('newServiceGroupName').getValue()));

																				treeStore = Ext.getCmp('serviceGroupsTreePanel').getStore();
																				treeStore.getRootNode().appendChild(h);

																				Ext.getCmp('newServiceGroupName').setValue("");
																				Ext.getCmp('newServiceGroupAlias').setValue("");

																			},
																			failure: function(batch, options) {
																				showError( l["Storage error"], l["Error"], batch);
																			}
																		}

																		servicegroupStore.sync(afterSync);
																	},
																	flex: 1,
																	id: 'saveNewServiceGroup',
																	text: 'Salvar',
																	listeners: {
																		beforerender: {
																			fn: me.onSaveNewServiceGroupBeforeRender,
																			scope: me
																		}
																	}
																}
															]
														}
													]
												},
												{
													xtype: 'panel',
													id: 'optionsServicePanel',
													bodyPadding: '20 10 0',
													header: false,
													title: 'My Panel',
													layout: {
														type: 'vbox',
														align: 'stretch'
													},
													items: [
														{
															xtype: 'form',
															flex: 1,
															id: 'addServiceToGroup',
															padding: 10,
															header: false,
															title: 'My Form',
															items: [
																{
																	xtype: 'label',
																	text: 'Adicionar serviços a grupos'
																},
																{
																	xtype: 'combobox',
																	anchor: '100%',
																	id: 'addServiceServicegroupServicegroup',
																	fieldLabel: 'Label',
																	hideLabel: true,
																	emptyText: 'Selecione o grupo',
																	displayField: 'servicegroup_name',
																	store: 'serviceGroupStore',
																	valueField: 'servicegroup_id'
																},
																{
																	xtype: 'combobox',
																	anchor: '100%',
																	id: 'addServiceServicegroupServices',
																	fieldLabel: 'Label',
																	hideLabel: true,
																	emptyText: 'Selecione os serviços',
																	displayField: 'label',
																	multiSelect: true,
																	store: 'alreadyMonitoredServiceStore',
																	valueField: 'service_id'
																},
																{
																	xtype: 'button',
																	handler: function(button, event) {
																		var servicegroupId;
																		var servicesIds;
																		var application;
																		var treeSort;
																		var alreadyMonitoredServicesStore;
																		var alreadyMonitoredHostsStore;
																		var serviceStore;
																		var params;
																		var node;
																		var members;
																		var label;
																		var found;
																		var newService;
																		var service;
																		var servicegroup;

																		servicegroupId = Ext.getCmp('addServiceServicegroupServicegroup').getValue();
																		servicesIds = Ext.getCmp('addServiceServicegroupServices').getValue();

																		application = Wizard.getApplication();
																		treeStore = Ext.getCmp('serviceGroupsTreePanel').getStore();
																		alreadyMonitoredServicesStore = application.getAlreadyMonitoredServiceStoreStore();
																		alreadyMonitoredHostsStore = application.getAlreadyMonitoredHostStoreStore();
																		serviceStore = application.getServiceStoreStore();

																		servicegroup = treeStore.getById(servicegroupId);
																		if (!servicegroup) {
																			return;
																		}

																		params = {};
																		params.servicegroup_name = servicegroup.get("servicegroup_name");
																		params.services_ids = JSON.stringify(servicesIds);

																		node = treeStore.getNodeById(servicegroupId);
																		if (!node) {
																			return;
																		}

																		members = servicegroup.get("members");
																		for(i=0; i<servicesIds.length; i++) {

																			monitoredService = alreadyMonitoredServicesStore.getById(servicesIds[i]);
																			monitoredHost = alreadyMonitoredHostsStore.getById(monitoredService.get("host_id"));

																			label = monitoredHost.get("host_name")+" "+monitoredService.get("service_description");

																			found = false;
																			for(j=0; j<members.length; j++) {
																				if (members[j].servicegroup_name == label) {
																					found = true;
																					break;
																				}
																			}

																			if (found) {
																				continue;
																			}

																			/* already monitored stuff */
																			newService = {
																				service_id: monitoredService.get("service_id") + Math.floor(Math.random()*50000) + Math.floor(Math.random()*50000),
																				service_description: monitoredService.get("service_description"),
																				servicegroup_id: monitoredService.get("service_id") + Math.floor(Math.random()*50000) + Math.floor(Math.random()*50000),
																				servicegroup_name: label,
																				host_name: monitoredHost.get("host_name"),
																				leaf:true
																			};

																			node.appendChild(newService);
																			members.push(newService);

																			/* being edited stuff */
																			service = serviceStore.getById(servicesIds[i]);
																			if (service) {
																				serviceServiceGroups = service.get("servicegroups");
																				serviceServiceGroups.push(servicegroupId);
																			}
																		}


																		addServicesToServicegroupOnServer(servicesIds,servicegroupId);
																		servicegroup.set("members",members);
																	},
																	id: 'applyServiceGroup',
																	text: 'Aplicar'
																}
															]
														},
														{
															xtype: 'button',
															handler: function(button, event) {
																Ext.getCmp('editServicePanel').getLayout().setActiveItem('newServiceGroup');
															},
															id: 'newServiceGroupBtn',
															margin: '0 0 10 0',
															glyph: 43,
															text: 'Novo grupo de serviço'
														}
													]
												}
											]
										}
									]
								}
							],
							listeners: {
								beforerender: {
									fn: me.onServicePanelBeforeRender,
									scope: me
								}
							}
						}
					]
				}
			],
			dockedItems: [
				{
					xtype: 'toolbar',
					flex: 1,
					dock: 'bottom',
					baseCls: 'x-toolbar-footer',
					id: 'navBar3',
					items: [
						{
							xtype: 'tbspacer',
							flex: 1
						},
						{
							xtype: 'container',
							items: [
								{
									xtype: 'button',
									handler: function(button, event) {
										var hostGrid;
										var serviceGrid;

										hostGrid = Ext.getCmp("hostGrid");
										if (hostGrid !== undefined) {
											hostGrid.getView().refresh();
										}

										serviceGrid = Ext.getCmp("serviceGrid");
										if (serviceGrid !== undefined) {
											serviceGrid.getView().refresh();
										}

										makeActiveView(Wizard.lastCard);

									},
									id: 'nextBtn3',
									text: 'Concluir',
									listeners: {
										beforerender: {
											fn: me.onNextBtn3BeforeRender,
											scope: me
										}
									}
								}
							]
						}
					]
				}
			]
		});

		me.callParent(arguments);
	},

	onHostGroupsTreeviewItemClick: function(dataview, record, item, index, e, eOpts) {
		Wizard.selectedRecord = record;

		if (dataview.menu === undefined) {
			dataview.menu = Ext.create("Wizard.view.removeMenu");
		}

		dataview.menu.show();
		dataview.menu.anchorTo(item.attributes['id'].nodeValue);
	},

	onHostGroupsTreePanelBeforeItemMove: function(nodeinterface, oldParent, newParent, index, eOpts) {
		hostName = nodeinterface.data.hostgroup_name;
		to = newParent.data.hostgroup_name;
		from = oldParent.data.hostgroup_name;

		if (newParent.hasHostNode(hostName)) {
			showInfo( l["Error"],l["Host Group already contains target host"]);
			return false;
		}

		host = getHostByName(hostName);
		if (host !== null) { /*host begin edited*/
			fromHostGroup = getHostGroupByName(oldParent.data.hostgroup_name);
			toHostGroup = getHostGroupByName(newParent.data.hostgroup_name);
			host.removeHostGroup(fromHostGroup.get("hostgroup_id"));
			host.addHostGroup(toHostGroup.get("hostgroup_id"));
		}

		Ext.getCmp('hostGroupsTreePanel').disable();
		Ext.Ajax.request({
			url: '/opmon/seagull/www/index.php/discovery/action/hostgroups/operation/hostchangedhostgroup/',
			method: 'POST',
			params: {
				host_name: hostName,
				from: from,
				to: to
			},
			success: function(result,request) {
				var obj;

				obj = JSON.parse(result.responseText);
				if (!obj) {
					showError(l["Unexpected error"], l["JSON not found"]);
					return;
				}

				if (!obj.success) {
					showError(l["Unexpected error"],obj.message);
					return;
				}

				Ext.getCmp('hostGroupsTreePanel').enable();

			},
			failure: function(result, request) {
				showError(l["Unexpected error"],l["Connection Error"]);
			}

		});

		return true;
	},

	onLabelBeforeRender: function(component, eOpts) {
		component.text = l["Set the group parameters"];
	},

	onNewHostGroupNameBlur: function(component, e, eOpts) {
		component.setValue(
			changeCharCode(component.getValue())
		);
	},

	onNewHostGroupNameBeforeRender: function(component, eOpts) {
		component.fieldLabel = l["Name"];
	},

	onNewHostGroupAliasBeforeRender: function(component, eOpts) {
		component.fieldLabel = l["Description"];
	},

	onSaveNewHostGroupBeforeRender: function(component, eOpts) {
		component.text = l["Save"];
	},

	onApplyHostGroupClick: function(button, e, eOpts) {
		var hostgroupId;
		var hostgroup;
		var hostsIds;
		var hosts;
		var application;
		var treeStore;
		var alreadyMonitoredHostsStore;
		var groupMembers;
		var newHost;
		var monitoredHost;
		var i;
		var node;
		var host;
		var hostsStore;
		var hostHostGroups;
		var j;
		var found;

		hostgroupId = Ext.getCmp('addHostHostgroupHostgroup').getValue();
		hostsIds = Ext.getCmp('addHostHostgroupHosts').getValue();

		application = Wizard.getApplication();
		treeStore = Ext.getCmp('hostGroupsTreePanel').getStore();
		alreadyMonitoredHostsStore = application.getAlreadyMonitoredHostStoreStore();
		hostsStore = application.getHostStoreStore();

		hostgroup = treeStore.getById(hostgroupId);
		if (!hostgroup) {
			return;
		}

		params = {};
		params.hostgroup_name = hostgroup.get("hostgroup_name");
		params.hostsIds = JSON.stringify(hostsIds);

		node = treeStore.getNodeById(hostgroupId);
		if (!node) {
			return;
		}

		members = hostgroup.get("members");
		for(i=0; i<hostsIds.length; i++) {

			monitoredHost = alreadyMonitoredHostsStore.getById(hostsIds[i]);

			found = false;
			for(j=0; j<members.length; j++) {
				if (members[j].host_name == monitoredHost.data.host_name) {
					found = true;
					break;
				}
			}

			if (found) {
				continue;
			}

			/* already monitored stuff */
			newHost = {
				host_id: monitoredHost.get("host_id") + Math.floor(Math.random()*11) + Math.floor(Math.random()*11),
				host_name: monitoredHost.get("host_name"),
				hostgroup_id: monitoredHost.get("host_id") + Math.floor(Math.random()*11) + Math.floor(Math.random()*11),
				hostgroup_name: monitoredHost.get("host_name"),
				leaf:true
			};

			node.appendChild(newHost);
			members.push(newHost);

			/* being edited stuff */
			host = hostsStore.getById(hostsIds[i]);
			if (host) {
				hostHostGroups = host.get("hostgroups");
				hostHostGroups.push(hostgroupId);
			}
		}

		addHostsToHostgroupOnServer(hostsIds,hostgroupId);

		hostgroup.set("members",members);
	},

	onHostPanelBeforeRender: function(component, eOpts) {
		component.title = l["Host Groups"];
	},

	onViewItemClick: function(dataview, record, item, index, e, eOpts) {
		Wizard.selectedRecord = record;

		if (dataview.menu === undefined) {
			dataview.menu = Ext.create("Wizard.view.removeMenu");
		}

		dataview.menu.show();
		dataview.menu.anchorTo(item.attributes['id'].nodeValue);
	},

	onServiceGroupsTreePanelBeforeItemMove: function(nodeinterface, oldParent, newParent, index, eOpts) {
		var serviceDescription;
		var from;
		var to;
		var i;
		var service;

		hostName = nodeinterface.get("host_name");
		serviceDescription = nodeinterface.get("service_description");

		to = newParent.data.servicegroup_name;
		from = oldParent.data.servicegroup_name;

		if (newParent.hasServiceNode(nodeinterface.servicegroup_name)) {
			showInfo( l["Error"], l["Already exists"]);
			return false;
		}

		Ext.getCmp('serviceGroupsTreePanel').disable();
		Ext.Ajax.request({

			url: '/opmon/seagull/www/index.php/discovery/action/servicegroups/operation/servicechangedservicegroup/',
			method: 'POST',
			params: {
				host_name: hostName,
				service_description: serviceDescription,
				from: from,
				to: to
			},
			success: function(result,request) {

				obj = JSON.parse(result.responseText);
				if (!obj) {
					showError(l["Unexpected error"],l["JSON not found"]);
					return;
				}

				if (!obj.success) {
					showError(l["Unexpected error"],obj.message);
					return;
				}

				Ext.getCmp('serviceGroupsTreePanel').enable();

			},
			failure: function(result, request) {
				showError(l["Unexpected error"],l["Connection Error"]);
			}

		});

		return true;
	},

	onLabelBeforeRender1: function(component, eOpts) {
		component.text = l["Set the group parameters"];
	},

	onNewServiceGroupNameBlur: function(component, e, eOpts) {
		component.setValue(
			changeCharCode(component.getValue())
		);
	},

	onNewServiceGroupNameBeforeRender: function(component, eOpts) {
		component.fieldLabel = l["Name"];
	},

	onNewServiceGroupAliasBeforeRender: function(component, eOpts) {
		component.fieldLabel = l["Description"];
	},

	onSaveNewServiceGroupBeforeRender: function(component, eOpts) {
		component.text = l["Save"];
	},

	onServicePanelBeforeRender: function(component, eOpts) {
		component.title = l["Service Groups"];
	},

	onNextBtn3BeforeRender: function(component, eOpts) {
		component.text = l.Complete;
	}

});