/*
 * File: app/view/editServices.js
 *
 * This file was generated by Sencha Architect
 * http://www.sencha.com/products/architect/
 *
 * This file requires use of the Ext JS 4.2.x library, under independent license.
 * License of Sencha Architect does not include license for Ext JS 4.2.x. For more
 * details see http://www.sencha.com/license or contact license@sencha.com.
 *
 * This file will be auto-generated each and everytime you save your project.
 *
 * Do NOT hand edit this file.
 */

Ext.define('Wizard.view.editServices', {
	extend: 'Ext.panel.Panel',
	alias: 'widget.editServices',

	requires: [
		'Wizard.view.ColumnCheckCommand',
		'Wizard.view.LabelCheckCmd',
		'Ext.grid.Panel',
		'Ext.grid.View',
		'Ext.grid.plugin.CellEditing',
		'Ext.grid.column.Template',
		'Ext.form.field.ComboBox',
		'Ext.form.field.Number',
		'Ext.grid.column.CheckColumn',
		'Ext.form.field.Checkbox',
		'Ext.grid.column.Number',
		'Ext.toolbar.Toolbar',
		'Ext.button.Button',
		'Ext.toolbar.Spacer',
		'Ext.form.Label'
	],

	height: 500,
	id: 'editServices',
	header: false,
	title: 'Selecione os serviços a monitorar e defina seus parâmetros',

	layout: {
		type: 'vbox',
		align: 'stretch'
	},

	initComponent: function() {
		var me = this;

		Ext.applyIf(me, {
			items: [
				{
					xtype: 'gridpanel',
					flex: 1,
					id: 'serviceGrid1',
					padding: '0 20 20',
					autoScroll: true,
					header: false,
					hideCollapseTool: true,
					title: 'My Grid Panel',
					titleCollapse: false,
					columnLines: false,
					enableColumnHide: false,
					enableColumnMove: false,
					forceFit: true,
					scroll: 'vertical',
					store: 'serviceStore',
					columns: [
						{
							xtype: 'gridcolumn',
							height: 59,
							id: 'serviceQuantColumn5',
							maxHeight: 59,
							maxWidth: 28,
							minHeight: 59,
							minWidth: 28,
							width: 28,
							resizable: false,
							sortable: false,
							dataIndex: 'count',
							text: '#'
						},
						{
							xtype: 'gridcolumn',
							height: 59,
							id: 'serviceNameColumn5',
							maxHeight: 59,
							minHeight: 59,
							width: 310,
							dataIndex: 'service_description',
							text: 'Nome do Serviço',
							flex: 6,
							editor: {
								xtype: 'textfield',
								id: 'editServiceName5',
								validateOnChange: false,
								enableKeyEvents: true,
								listeners: {
									blur: {
										fn: me.onEditServiceName5Blur,
										scope: me
									}
								}
							},
							listeners: {
								beforerender: {
									fn: me.onServiceNameColumn5BeforeRender,
									scope: me
								}
							}
						},
						{
							xtype: 'gridcolumn',
							id: 'check_service1',
							text: 'Checagem',
							columns: [
								{
									xtype: 'columncheckcommand'
								},
								{
									xtype: 'gridcolumn',
									renderer: function(value, metaData, record, rowIndex, colIndex, store, view) {
										var timeperiods;
										var tp;
										var i;
										var me;

										timeperiods = Wizard.getApplication().getTimePeriodStoreStore();
										if (timeperiods.isLoading()) {
											me = this;
											setTimeout(
											function() {
												me.getView().refresh();
											},
											300
											);
											return " ";
										}

										if (value === undefined) {
											value = record.data.check_period;
										}

										for(i=0; i<timeperiods.data.items.length; i++) {
											tp = timeperiods.data.items[i].data;
											if (tp.id == value)
											return tp.timeperiod_name;
										}

										return " ";
									},
									draggable: false,
									id: 'checkPeriodColumn7',
									maxWidth: 110,
									minWidth: 110,
									resizable: false,
									sortable: true,
									dataIndex: 'check_period',
									text: 'Período',
									flex: 2,
									editor: {
										xtype: 'combobox',
										id: 'editCheckPeriod7',
										displayField: 'timeperiod_name',
										queryMode: 'local',
										store: 'timePeriodStore',
										valueField: 'timeperiod_id'
									},
									listeners: {
										beforerender: {
											fn: me.onCheckPeriodColumn04BeforeRender1,
											scope: me
										}
									}
								},
								{
									xtype: 'gridcolumn',
									draggable: false,
									frame: false,
									id: 'timePeriodColumn10',
									maxWidth: 60,
									minWidth: 60,
									resizable: false,
									sortable: true,
									dataIndex: 'normal_check_interval',
									menuText: 'Intervalo',
									text: 'Intervalo',
									flex: 1,
									editor: {
										xtype: 'numberfield',
										id: 'editTimePeriod10',
										decimalPrecision: 0,
										step: 10
									},
									listeners: {
										beforerender: {
											fn: me.onTimePeriodColumn04BeforeRender1,
											scope: me
										}
									}
								},
								{
									xtype: 'gridcolumn',
									draggable: false,
									frame: false,
									id: 'timePeriodColumn11',
									maxWidth: 60,
									minWidth: 60,
									resizable: false,
									sortable: true,
									align: 'right',
									dataIndex: 'retry_check_interval',
									menuText: 'OOOO',
									text: 'Retry interval',
									flex: 1,
									editor: {
										xtype: 'numberfield',
										id: 'editTimePeriod11',
										decimalPrecision: 0
									},
									listeners: {
										beforerender: {
											fn: me.onTimePeriodColumn02BeforeRender111,
											scope: me
										}
									}
								},
								{
									xtype: 'gridcolumn',
									draggable: false,
									frame: false,
									id: 'timePeriodColumn12',
									maxWidth: 60,
									minWidth: 60,
									width: 60,
									resizable: false,
									sortable: true,
									align: 'right',
									dataIndex: 'max_check_attempts',
									menuText: 'OOOO',
									text: 'Maximum Attempts',
									flex: 1,
									editor: {
										xtype: 'numberfield',
										id: 'editTimePeriod12',
										decimalPrecision: 0
									},
									listeners: {
										beforerender: {
											fn: me.onTimePeriodColumn02BeforeRender211,
											scope: me
										}
									}
								}
							],
							listeners: {
								beforerender: {
									fn: me.onCheckAllColumn04BeforeRender1,
									scope: me
								},
								hide: {
									fn: me.onCheck_service1Hide,
									scope: me
								},
								show: {
									fn: me.onCheck_service1Show,
									scope: me
								}
							}
						},
						{
							xtype: 'gridcolumn',
							hidden: true,
							id: 'extended_info_service1',
							dataIndex: 'extended_info',
							text: 'Informações estendidas',
							columns: [
								{
									xtype: 'gridcolumn',
									id: 'service_action1',
									minWidth: 200,
									width: 200,
									sortable: false,
									dataIndex: 'action_url',
									text: 'Action URL',
									editor: {
										xtype: 'textfield',
										listeners: {
											blur: {
												fn: me.onTextfieldBlur31,
												scope: me
											}
										}
									},
									listeners: {
										click: {
											fn: me.onHostIcon1Click11,
											scope: me
										},
										beforerender: {
											fn: me.onHostIcon1BeforeRender11,
											scope: me
										}
									}
								},
								{
									xtype: 'gridcolumn',
									id: 'service_note1',
									minWidth: 200,
									width: 200,
									sortable: false,
									dataIndex: 'notes_url',
									text: 'Note URL',
									editor: {
										xtype: 'textfield',
										listeners: {
											blur: {
												fn: me.onTextfieldBlur111,
												scope: me
											}
										}
									},
									listeners: {
										click: {
											fn: me.onHostIcon2Click11,
											scope: me
										},
										beforerender: {
											fn: me.onHostIcon2BeforeRender11,
											scope: me
										}
									}
								}
							],
							listeners: {
								hide: {
									fn: me.onExtended_info_serviceHide1,
									scope: me
								},
								show: {
									fn: me.onExtended_info_serviceShow1,
									scope: me
								},
								beforerender: {
									fn: me.onExtended_info_service1BeforeRender,
									scope: me
								}
							}
						},
						{
							xtype: 'gridcolumn',
							hidden: true,
							id: 'service_notifications1',
							maxWidth: 230,
							minWidth: 230,
							width: 230,
							enableColumnHide: false,
							text: 'Notificações',
							columns: [
								{
									xtype: 'checkcolumn',
									id: 'service_notification_enabled1',
									width: 60,
									sortable: true,
									dataIndex: 'notifications_enabled',
									text: 'Ativa',
									editor: {
										xtype: 'checkboxfield'
									},
									listeners: {
										beforerender: {
											fn: me.onHost_notification_enabledBeforeRender11,
											scope: me
										},
										checkchange: {
											fn: me.onService_notification_enabled1CheckChange,
											scope: me
										}
									}
								},
								{
									xtype: 'gridcolumn',
									renderer: function(value, metaData, record, rowIndex, colIndex, store, view) {
										var timeperiods;
										var tp;
										var i;
										var me;

										timeperiods = Wizard.getApplication().getTimePeriodStoreStore();
										if (timeperiods.isLoading()) {
											me = this;
											setTimeout(
											function() {
												me.getView().refresh();
											},
											300
											);
											return " ";
										}

										if (value === undefined) {
											value = record.data.notification_period;
										}

										for(i=0; i<timeperiods.data.items.length; i++) {
											tp = timeperiods.data.items[i].data;
											if (tp.id == value) {
												record.data.notification_period = value;
												return tp.timeperiod_name;
											}
										}

										return "";
									},
									id: 'service_notification_period1',
									width: 100,
									sortable: true,
									dataIndex: 'notification_period',
									text: 'Período',
									editor: {
										xtype: 'combobox',
										displayField: 'timeperiod_name',
										store: 'timePeriodStore',
										valueField: 'timeperiod_id'
									},
									listeners: {
										beforerender: {
											fn: me.onHost_notification_periodBeforeRender11,
											scope: me
										}
									}
								},
								{
									xtype: 'numbercolumn',
									id: 'service_notification_interval2',
									width: 70,
									sortable: true,
									dataIndex: 'notification_interval',
									text: 'Intervalo',
									format: '0',
									editor: {
										xtype: 'numberfield'
									},
									listeners: {
										beforerender: {
											fn: me.onHost_notification_intervalBeforeRender11,
											scope: me
										}
									}
								}
							],
							listeners: {
								beforerender: {
									fn: me.onHost_notificationsBeforeRender11,
									scope: me
								},
								hide: {
									fn: me.onHost_notificationsHide11,
									scope: me
								},
								show: {
									fn: me.onHost_notificationsShow11,
									scope: me
								}
							}
						},
						{
							xtype: 'gridcolumn',
							renderer: function(value, metaData, record, rowIndex, colIndex, store, view) {
								var i;
								var servicegroups;
								var servicegroup;
								var label = new Array();
								var me;

								servicegroups = Wizard.getApplication().getServiceGroupStoreStore();
								if (servicegroups.isLoading()) {
									me = this;
									setTimeout(
									function() {
										me.getView().refresh();
									},
									300
									);
									return null;
								}

								if (record.data.servicegroups.length === 0) {
									return null;
								}

								for(i=0; i<record.data.servicegroups.length; i++) {
									servicegroup = servicegroups.getById(record.data.servicegroups[i]);
									if (servicegroup !== null) {
										label.push(servicegroup.data.servicegroup_name);
									}
								}

								if (label.length == 0) {
									return null;
								}

								return label.join(", ");
							},
							height: 59,
							id: 'serviceGroupsColumn5',
							maxWidth: 230,
							minWidth: 230,
							width: 230,
							dataIndex: 'servicegroups',
							menuText: 'Texto',
							text: 'Grupos de Serviço',
							editor: {
								xtype: 'combobox',
								id: 'editServiceGroups5',
								labelPad: 0,
								displayField: 'servicegroup_name',
								enableRegEx: false,
								multiSelect: true,
								queryMode: 'local',
								store: 'serviceGroupStore',
								valueField: 'servicegroup_id'
							},
							listeners: {
								beforerender: {
									fn: me.onServiceGroupsColumn04BeforeRender1,
									scope: me
								}
							}
						}
					],
					viewConfig: {
						minHeight: 250
					},
					plugins: [
						Ext.create('Ext.grid.plugin.CellEditing', {
							clicksToEdit: 1,
							listeners: {
								validateedit: {
									fn: me.onCellEditingValidateedit,
									scope: me
								},
								beforeedit: {
									fn: me.onCellEditingBeforeEdit,
									scope: me
								}
							}
						})
					],
					dockedItems: [
						{
							xtype: 'toolbar',
							dock: 'bottom',
							id: 'editGroupsBar8',
							items: [
								{
									xtype: 'button',
									handler: function(button, event) {
										makeActiveView("servicesContacts");
										Ext.getCmp("servicesContacts").groupedServices = {};
										Ext.getCmp("servicesContacts").last_view = "editServices";
									},
									id: 'editContactsBtn9',
									text: 'Alterar Equipes e Responsáveis',
									listeners: {
										beforerender: {
											fn: me.onEditGroupsBtn5BeforeRender111,
											scope: me
										}
									}
								},
								{
									xtype: 'tbspacer',
									flex: 1
								},
								{
									xtype: 'button',
									handler: function(button, e) {
										Ext.getCmp("service_notifications1").setVisible(!button.pressed);
										Ext.getCmp("extended_info_service1").setVisible(false);
										Ext.getCmp("check_service1").setVisible(button.pressed);
									},
									id: 'check_services1',
									enableToggle: true,
									text: 'Editar checagens',
									listeners: {
										beforerender: {
											fn: me.onSs_notifications1BeforeRender,
											scope: me
										}
									}
								},
								{
									xtype: 'button',
									handler: function(button, e) {
										Ext.getCmp("service_notifications1").setVisible(button.pressed);
										Ext.getCmp("extended_info_service1").setVisible(false);
										Ext.getCmp("check_service1").setVisible(!button.pressed);
									},
									id: 'ss_notifications1',
									enableToggle: true,
									text: 'Editar notificações',
									listeners: {
										beforerender: {
											fn: me.onSs_notifications1BeforeRender1,
											scope: me
										}
									}
								},
								{
									xtype: 'button',
									handler: function(button, e) {
										Ext.getCmp("extended_info_service1").setVisible(button.pressed);
										Ext.getCmp("service_notifications1").setVisible(false);
										Ext.getCmp("check_service1").setVisible(!button.pressed);
									},
									id: 'ei_services1',
									enableToggle: true,
									text: 'Editar informações estendidas',
									listeners: {
										beforerender: {
											fn: me.onEi_hostsBeforeRender11,
											scope: me
										}
									}
								},
								{
									xtype: 'button',
									handler: function(button, event) {
										makeActiveView("editGroupsPanel");
									},
									id: 'editGroupsBtn8',
									text: 'Editar Grupos de Serviço',
									listeners: {
										beforerender: {
											fn: me.onEditGroupsBtn04BeforeRender1,
											scope: me
										}
									}
								}
							]
						},
						{
							xtype: 'toolbar',
							dock: 'top',
							items: [
								{
									xtype: 'container',
									cls: 'bold',
									id: 'modalDescriptionText8',
									listeners: {
										beforerender: {
											fn: me.onModalDescriptionText2BeforeRender111,
											scope: me
										},
										render: {
											fn: me.onModalDescriptionText8Render,
											scope: me
										},
										resize: {
											fn: me.onModalDescriptionText8Resize,
											scope: me
										}
									}
								},
								{
									xtype: 'tbspacer',
									flex: 1
								},
								{
									xtype: 'label',
									margin: '3 0 5 0',
									text: 'My Label',
									listeners: {
										beforerender: {
											fn: me.onLabelBeforeRender111,
											scope: me
										}
									}
								},
								{
									xtype: 'container',
									id: 'service_check_filter',
									margin: 0,
									layout: {
										type: 'hbox',
										align: 'stretch'
									},
									items: [
										{
											xtype: 'labelcheckcmd',
											screen: 'editServices',
											store: 'serviceStore',
											flex: 1
										},
										{
											xtype: 'combobox',
											flex: 2,
											id: 'ediCheckPeriodAll7',
											margin: '0 5',
											maxWidth: 100,
											minWidth: 100,
											fieldLabel: 'Label',
											hideLabel: true,
											labelAlign: 'top',
											labelWidth: 0,
											anyMatch: true,
											displayField: 'timeperiod_name',
											forceSelection: true,
											queryMode: 'local',
											store: 'timePeriodStore',
											valueField: 'timeperiod_id',
											listeners: {
												change: {
													fn: me.onComboboxChange221,
													scope: me
												}
											}
										},
										{
											xtype: 'numberfield',
											flex: 1,
											id: 'editTimePeriodAll10',
											margin: '0 5',
											maxWidth: 50,
											minWidth: 50,
											width: 50,
											fieldLabel: '',
											labelSeparator: ' ',
											allowDecimals: false,
											minText: ''+Ext.locale.translate('Min')+'. 1',
											minValue: 1,
											step: 5,
											listeners: {
												change: {
													fn: me.onNumberfieldChange131,
													scope: me
												}
											}
										},
										{
											xtype: 'numberfield',
											flex: 1,
											id: 'editTimePeriodAll12',
											margin: '0 5',
											maxWidth: 50,
											minWidth: 50,
											width: 50,
											fieldLabel: '',
											labelSeparator: ' ',
											allowDecimals: false,
											minText: ''+Ext.locale.translate('Min')+'. 1',
											minValue: 1,
											step: 5,
											listeners: {
												change: {
													fn: me.onNumberfieldChange1111,
													scope: me
												}
											}
										},
										{
											xtype: 'numberfield',
											flex: 1,
											id: 'editTimePeriodAll13',
											margin: '0 5',
											maxWidth: 50,
											minWidth: 50,
											width: 50,
											fieldLabel: '',
											labelSeparator: ' ',
											minText: ''+Ext.locale.translate('Min')+'. 1',
											minValue: 1,
											step: 5,
											listeners: {
												change: {
													fn: me.onNumberfieldChange1112,
													scope: me
												}
											}
										}
									]
								},
								{
									xtype: 'container',
									hidden: true,
									id: 'all_service_extended_info1',
									layout: {
										type: 'hbox',
										align: 'stretch'
									},
									items: [
										{
											xtype: 'textfield',
											margin: '0 5',
											width: 190,
											fieldLabel: '',
											listeners: {
												blur: {
													fn: me.onTextfieldBlur221,
													scope: me
												}
											}
										},
										{
											xtype: 'textfield',
											margin: '0 0 0 5',
											width: 190,
											fieldLabel: '',
											listeners: {
												blur: {
													fn: me.onTextfieldBlur2111,
													scope: me
												}
											}
										}
									]
								},
								{
									xtype: 'container',
									hidden: true,
									id: 'all_service_notification1',
									margin: '0 0 0 0',
									layout: {
										type: 'hbox',
										align: 'stretch'
									},
									items: [
										{
											xtype: 'checkboxfield',
											id: 'all_host_notification_enabled2',
											margin: '0 23',
											fieldLabel: '',
											boxLabel: '',
											listeners: {
												change: {
													fn: me.onAll_host_notification_enabledChange11,
													scope: me
												}
											}
										},
										{
											xtype: 'combobox',
											id: 'all_host_notification_period2',
											margin: '0 5',
											maxWidth: 90,
											minWidth: 90,
											fieldLabel: 'Label',
											hideLabel: true,
											labelAlign: 'top',
											labelWidth: 0,
											displayField: 'timeperiod_name',
											forceSelection: true,
											queryMode: 'local',
											store: 'timePeriodStore',
											valueField: 'timeperiod_id',
											listeners: {
												change: {
													fn: me.onComboboxChange2111,
													scope: me
												}
											}
										},
										{
											xtype: 'numberfield',
											id: 'all_host_notification_interval2',
											margin: '0 5',
											width: 60,
											fieldLabel: '',
											labelSeparator: ' ',
											minValue: 1,
											step: 5,
											listeners: {
												change: {
													fn: me.onNumberfieldChange1211,
													scope: me
												}
											}
										}
									]
								},
								{
									xtype: 'combobox',
									id: 'editHostGroupsAll4',
									margin: '0 5',
									width: 220,
									fieldLabel: ' ',
									hideLabel: true,
									labelAlign: 'top',
									labelSeparator: ' ',
									anyMatch: true,
									displayField: 'servicegroup_name',
									forceSelection: true,
									multiSelect: true,
									queryMode: 'local',
									store: 'serviceGroupStore',
									valueField: 'servicegroup_id',
									listeners: {
										change: {
											fn: me.onComboboxChange11,
											scope: me
										}
									}
								}
							]
						}
					],
					listeners: {
						render: {
							fn: me.onServiceGrid1Render,
							scope: me
						}
					}
				}
			],
			dockedItems: [
				{
					xtype: 'toolbar',
					flex: 1,
					dock: 'bottom',
					baseCls: 'x-toolbar-footer',
					id: 'navBar14',
					items: [
						{
							xtype: 'tbspacer',
							flex: 1
						},
						{
							xtype: 'container',
							items: [
								{
									xtype: 'button',
									handler: function(button, event) {
										me = Ext.getCmp('editServices');

										var services = Wizard.getApplication().getServiceStoreStore();
										var updatedServices = [];
										var grouped = me.groupedServices;
										var error_msg_title = l["Invalid Configuration"];
										var error_msg_description = l["All services must contain at least one user or team responsible"];

										for (var group in grouped) {
											var services_grouped = grouped[group].services;
											services_grouped.map(returnServiceId);
										}

										function returnServiceId(item) {
											var updatedValues = Array.isArray(item) ? item.map(returnServiceId) : updatedServices.push(keepServiceIntegrity(findRecordBykeyId(item.key_id),item));
										}

										function keepServiceIntegrity(updatedValues,originalObj) {
											updatedValues.service_id = originalObj.service_id;
											updatedValues.host_id = originalObj.host_id;
											updatedValues.host_name = originalObj.host_name;
											return updatedValues;
										}

										function findRecordBykeyId(key_id) {
											var record = services.findRecord("key_id", key_id);
											//return verifyContacts(record.getData()); Retirado no ticket #10400
											return record.getData();
										}

										function verifyContacts(content) {
											var content_contact_groups = (content.contactgroups.length === 0 && content.contacts.length === 0) ? showError(error_msg_title, error_msg_description) : content;
											return content_contact_groups;
										}


										if (me.running) {showError(l['Unexpected error'], l['Updating']);return;}
										Ext.Msg.show({
											title: l.Confirmation,
											msg: l['Do you really want to apply all the changes ?'],
											buttonText: { yes: l['Yes'], cancel: l['No'] },
											fn: function(btn){
												if(btn !== 'yes')
												return;
												me.running = true;
												if(! Wizard.clone) {
													Ext.Ajax.request({
														url: '/opmon/seagull/www/index.php/discovery/action/saveservices/',
														method: 'POST',
														params: {
															services: JSON.stringify(updatedServices)
														},
														success: function(result, request) {

															var wsreturn;

															try {
																wsreturn = JSON.parse(result.responseText);
															} catch(err) {
																showError(l["Unexpected error"],err.message);
																me.running = false;
																return;
															}

															if (!wsreturn.success) {
																showError(l["Unexpected error"], wsreturn.message);
																me.running = false;
																return;
															}

															if (Wizard.endCallBack) {
																func = "parent."+Wizard.endCallBack+"(true);";
																me.running = false;
																eval(func);
															}

														},
														failure: function(object, request) {
															me.running = false;
															showError(l.Error,l["Unexpected error"], request.responseText, request);
														}

													});
												} else {
													Wizard.endCallBack();
												}
											}
										});
									},
									id: 'nextBtn14',
									text: 'Salvar alterações',
									listeners: {
										beforerender: {
											fn: me.onNextBtn14BeforeRender,
											scope: me
										}
									}
								}
							]
						}
					]
				}
			]
		});

		me.callParent(arguments);
	},

	onEditServiceName5Blur: function(component, e, eOpts) {
		component.setValue(
			changeCharCode(component.getValue())
		);
	},

	onServiceNameColumn5BeforeRender: function(component, eOpts) {
		component.text = l["Service Name"];
		component.tooltip = l["Service Name"];
		component.menuText = l["Service Name"];
	},

	onCellEditingValidateedit: function(editor, e, eOpts) {
		/**
		* something has changed on the grid, we have
		* to determine which record has been changed
		* and which property, once we detect that, we
		* have to update all services that have the
		* same check command and service description
		*
		* we group services by check command and service
		* description and keep a track of them on
		* `groupedServices' property of `editServices'
		* window
		*/

		if (e.value === e.originalValue) /* nothing has changed */
			return;

		var me = Ext.getCmp("editServices");
		var svcidx = e.record.get("original_check_command")+"-"+e.record.get("original_service_description");

		/* this is not supposed to happen */
		if (me.groupedServices[svcidx] === undefined)
			return;

		/* update all group services */
		var group = me.groupedServices[svcidx];
		Ext.each(group.services, function(svc){
			svc[e.field] = e.value;
		});

		var store = Ext.getStore('serviceStore');
		Wizard.wizard.getController('EditHostsController').onEditCellGrid(store, e, 'editServices');
	},

	onCellEditingBeforeEdit: function(editor, e, eOpts) {
		if (e.record.get('is_scat')) {
			if (e.field === 'service_description') {
				return false;
			}
		}
	},

	onCheckPeriodColumn04BeforeRender1: function(component, eOpts) {
		component.text = l["Period"];
		component.menuText = l["Period"];
		component.tooltip = l['Check Period'];
	},

	onTimePeriodColumn04BeforeRender1: function(component, eOpts) {
		component.text = l["Interval"];
		component.menuText = l["Interval"];
		component.tooltip = l['Check Interval'];
	},

	onCheckAllColumn04BeforeRender1: function(component, eOpts) {
		component.text = l["Check"];
		component.tooltip = l["Check"];
		component.menuText = l["Check"];
	},

	onTimePeriodColumn02BeforeRender111: function(component, eOpts) {
		component.text = l['Retry interval'];
		component.tooltip = l['Retry check interval'];
		component.menuText = l["Retry check interval"];
	},

	onTimePeriodColumn02BeforeRender211: function(component, eOpts) {
		component.text = l['Maximum Attempts'];
		component.tooltip = l['Maximum Check Attempts'];
		component.menuText = l["Maximum Check Attempts"];
	},

	onCheck_service1Hide: function(component, eOpts) {
		Ext.get('service_check_filter').setVisible(false);
		Ext.getCmp("check_services1").toggle(false);
	},

	onCheck_service1Show: function(component, eOpts) {
		Ext.get('service_check_filter').setVisible(true);
		Ext.getCmp("check_services1").toggle(true);
	},

	onTextfieldBlur31: function(component, e, eOpts) {
		var extendedPosition = Ext.getStore("extendedPosition");
		var record_position = extendedPosition.getAt(0);
		var serviceStore = Ext.getStore("serviceStore");
		var serviceData = serviceStore.getAt(record_position.data.position);
		serviceData.data.extended_info.action_url = component.value;
	},

	onHostIcon1Click11: function(grid, el, position) {
		var extendedPosition = Ext.getStore("extendedPosition");
		extendedPosition.removeAll();
		extendedPosition.add({position: position});
	},

	onHostIcon1BeforeRender11: function(component, eOpts) {
		component.text = l['Action URL'];
		component.tooltip = l['Action URL'];
		component.menuText = l["Action URL"];
	},

	onTextfieldBlur111: function(component, e, eOpts) {
		var extendedPosition = Ext.getStore("extendedPosition");
		var record_position = extendedPosition.getAt(0);
		var serviceStore = Ext.getStore("serviceStore");
		var serviceData = serviceStore.getAt(record_position.data.position);
		serviceData.data.extended_info.notes_url = component.value;
	},

	onHostIcon2Click11: function(grid, el, position) {
		var extendedPosition = Ext.getStore("extendedPosition");
		extendedPosition.removeAll();
		extendedPosition.add({position: position});
	},

	onHostIcon2BeforeRender11: function(component, eOpts) {
		component.text = l['Note URL'];
		component.tooltip = l['Note URL'];
		component.menuText = l['Note URL'];
	},

	onExtended_info_serviceHide1: function(component, eOpts) {
		Ext.getCmp("all_service_extended_info1").setVisible(false);
		Ext.getCmp("ei_services1").toggle(false);
	},

	onExtended_info_serviceShow1: function(component, eOpts) {
		Ext.getCmp("all_service_extended_info1").setVisible(true);
		Ext.getCmp("ei_services1").toggle(true);
	},

	onExtended_info_service1BeforeRender: function(component, eOpts) {
		component.text = l["Extended information"];
		component.tooltip = l["Extended information"];
		component.menuText = l["Extended information"];
	},

	onHost_notification_enabledBeforeRender11: function(component, eOpts) {
		component.text = l['Enabled'];
		component.tooltip = l['Notification enabled'];
		component.menuText = l['Notification enabled'];
	},

	onService_notification_enabled1CheckChange: function(checkcolumn, rowIndex, checked, eOpts) {
		var serviceStore = Ext.getStore("serviceStore");
		var serviceData = serviceStore.getAt(rowIndex);
		serviceData.data.notifications_enabled = checked;
	},

	onHost_notification_periodBeforeRender11: function(component, eOpts) {
		component.text = l['Period'];
		component.tooltip = l['Notification period'];
		component.menuText = l['Notification period'];
	},

	onHost_notification_intervalBeforeRender11: function(component, eOpts) {
		component.text = l['Interval'];
		component.tooltip = l['Notification interval'];
		component.menuText = l['Notification interval'];
	},

	onHost_notificationsBeforeRender11: function(component, eOpts) {
		component.text = l['Notifications'];
		component.menuText = l['Notifications'];
		component.tooltip = l['Notifications'];
	},

	onHost_notificationsHide11: function(component, eOpts) {
		Ext.getCmp("all_service_notification1").setVisible(false);
		Ext.getCmp("ss_notifications1").toggle(false);
		// Ext.getCmp("service_checks").setMargin("0 16 0 0");
	},

	onHost_notificationsShow11: function(component, eOpts) {
		Ext.getCmp("all_service_notification1").setVisible(true);
		Ext.getCmp("ss_notifications1").toggle(true);
		// Ext.getCmp("service_checks").setMargin("0 0 0 0");
	},

	onServiceGroupsColumn04BeforeRender1: function(component, eOpts) {
		component.text = l["Service Groups"];
		component.tooltip = l["Service Groups"];
		component.menuText = l["Service Groups"];
	},

	onEditGroupsBtn5BeforeRender111: function(component, eOpts) {
		component.text = l["Change Teams and Team members"];
	},

	onSs_notifications1BeforeRender: function(component, eOpts) {
		component.text = l['Edit checks'];
		component.pressed = true;
	},

	onSs_notifications1BeforeRender1: function(component, eOpts) {
		component.text = l['Edit notifications'];
	},

	onEi_hostsBeforeRender11: function(component, eOpts) {
		component.text = l['Edit extended information'];
	},

	onEditGroupsBtn04BeforeRender1: function(component, eOpts) {
		component.text = l["Create Service Groups"];
	},

	onModalDescriptionText2BeforeRender111: function(component, eOpts) {
		component.html = l["Set the services parameters"];

	},

	onModalDescriptionText8Render: function(component, eOpts) {
		if (component.width < 300) {
			component.hide();
		} else {
			component.show();
		}
	},

	onModalDescriptionText8Resize: function(component, width, height, oldWidth, oldHeight, eOpts) {
		if (width < 300) {
			component.hide();
		} else {
			component.show();
		}
	},

	onLabelBeforeRender111: function(component, eOpts) {
		component.text = l['Apply to all services'];
	},

	onComboboxChange221: function(field, newValue, oldValue, eOpts) {
		var services;
		var service;
		var i;
		var grid;

		services = Wizard.getApplication().getServiceStoreStore();

		if (newValue !== "") {
			var commandExist = Ext.getStore('timePeriodStore').data.items.filter(function(curr) {
				return curr.raw.timeperiod_name === newValue || curr.raw.timeperiod_id === newValue;
			});

			if(commandExist.length) {
				for(i=0; i<services.data.items.length; i++) {
					service = services.data.items[i];
					service.data.check_period = newValue;
				}

				grid = Ext.getCmp("serviceGrid1");
				grid.getView().refresh();
			}
		}
	},

	onNumberfieldChange131: function(field, newValue, oldValue, eOpts) {
		var services;
		var service;
		var i;
		var grid;

		if(newValue > 0) {
			services = Wizard.getApplication().getServiceStoreStore();

			for(i=0; i<services.data.items.length; i++) {
				service = services.data.items[i];
				service.data.normal_check_interval = newValue;
			}

			grid = Ext.getCmp("serviceGrid1");
			grid.getView().refresh();
		}
	},

	onNumberfieldChange1111: function(field, newValue, oldValue, eOpts) {
		var services;
		var service;
		var i;
		var grid;

		if(newValue > 0) {
			services = Wizard.getApplication().getServiceStoreStore();

			for(i=0; i<services.data.items.length; i++) {
				service = services.data.items[i];
				service.data.retry_check_interval = newValue;
			}

			grid = Ext.getCmp("serviceGrid1");
			grid.getView().refresh();
		}
	},

	onNumberfieldChange1112: function(field, newValue, oldValue, eOpts) {
		var services;
		var service;
		var i;
		var grid;

		if(newValue > 0) {
			services = Wizard.getApplication().getServiceStoreStore();

			for(i=0; i<services.data.items.length; i++) {
				service = services.data.items[i];
				service.data.max_check_attempts = newValue;
			}

			grid = Ext.getCmp("serviceGrid1");
			grid.getView().refresh();
		}
	},

	onTextfieldBlur221: function(component, e, eOpts) {
		var services;
		var service;
		var i;
		var grid;

		services = Wizard.getApplication().getServiceStoreStore();

		for(i=0; i<services.data.items.length; i++) {
			service = services.data.items[i];
			service.data.extended_info.action_url = component.value;
			service.data.action_url = component.value;
		}

		grid = Ext.getCmp("serviceGrid1");
		grid.getView().refresh();
	},

	onTextfieldBlur2111: function(component, e, eOpts) {
		var services;
		var service;
		var i;
		var grid;

		services = Wizard.getApplication().getServiceStoreStore();

		for(i=0; i<services.data.items.length; i++) {
			service = services.data.items[i];
			service.data.extended_info.note_url = component.value;
			service.data.note_url = component.value;
		}

		grid = Ext.getCmp("serviceGrid1");
		grid.getView().refresh();
	},

	onAll_host_notification_enabledChange11: function(field, newValue, oldValue, eOpts) {
		var services;
		var service;
		var i;
		var grid;

		services = Wizard.getApplication().getServiceStoreStore();

		for(i=0; i<services.data.items.length; i++) {
			service = services.data.items[i];
			service.data.notifications_enabled = newValue;
		}

		grid = Ext.getCmp("serviceGrid1");
		grid.getView().refresh();
	},

	onComboboxChange2111: function(field, newValue, oldValue, eOpts) {
		var services;
		var service;
		var i;
		var grid;

		services = Wizard.getApplication().getServiceStoreStore();

		if (newValue !== "") {
			var commandExist = Ext.getStore('timePeriodStore').data.items.filter(function(curr) {
				return curr.raw.timeperiod_name === newValue || curr.raw.timeperiod_id === newValue;
			});

			if(commandExist.length) {
				for(i=0; i<services.data.items.length; i++) {
					service = services.data.items[i];
					service.data.notification_period = newValue;
				}

				grid = Ext.getCmp("serviceGrid1");
				grid.getView().refresh();
			}
		}
	},

	onNumberfieldChange1211: function(field, newValue, oldValue, eOpts) {
		var services;
		var service;
		var i;
		var grid;

		if(newValue > 0) {
			services = Wizard.getApplication().getServiceStoreStore();

			for(i=0; i<services.data.items.length; i++) {
				service = services.data.items[i];
				service.data.notification_interval = newValue;
			}

			grid = Ext.getCmp("serviceGrid1");
			grid.getView().refresh();
		}
	},

	onComboboxChange11: function(field, newValue, oldValue, eOpts) {
		var services;
		var service;
		var i;
		var grid;

		services = Wizard.getApplication().getServiceStoreStore();

		for(i=0; i<services.data.items.length; i++) {
			service = services.data.items[i];
			service.data.servicegroups = newValue;
		}

		grid = Ext.getCmp("serviceGrid1");
		grid.getView().refresh();
	},

	onServiceGrid1Render: function(component, eOpts) {
		var store = Ext.getStore('serviceStore');
		Wizard.wizard.getController('EditHostsController').validateStore(store, 'editServices');
	},

	onNextBtn14BeforeRender: function(component, eOpts) {
		component.text = l["Save Changes"];
	}

});