/*
 * File: app/view/removeHost.js
 *
 * This file was generated by Sencha Architect
 * http://www.sencha.com/products/architect/
 *
 * This file requires use of the Ext JS 4.2.x library, under independent license.
 * License of Sencha Architect does not include license for Ext JS 4.2.x. For more
 * details see http://www.sencha.com/license or contact license@sencha.com.
 *
 * This file will be auto-generated each and everytime you save your project.
 *
 * Do NOT hand edit this file.
 */

Ext.define('Wizard.view.removeHost', {
	extend: 'Ext.window.Window',

	requires: [
		'Ext.form.Label',
		'Ext.grid.Panel',
		'Ext.grid.column.CheckColumn',
		'Ext.grid.View',
		'Ext.toolbar.Toolbar',
		'Ext.toolbar.Spacer',
		'Ext.button.Button',
		'Ext.Img'
	],

	draggable: false,
	id: 'removeHost',
	width: 500,
	header: false,
	title: 'Remover o(s) host(s)?',
	modal: true,

	initComponent: function() {
		var me = this;

		Ext.applyIf(me, {
			items: [
				{
					xtype: 'container',
					id: 'delHostContainer',
					width: 510,
					layout: 'card',
					items: [
						{
							xtype: 'container',
							items: [
								{
									xtype: 'container',
									id: 'serviceParamsPanel2',
									minHeight: 100,
									layout: {
										type: 'vbox',
										align: 'center',
										pack: 'center',
										padding: 20
									},
									items: [
										{
											xtype: 'label',
											flex: 1,
											id: 'messageRemoveHost',
											shrinkWrap: 1,
											width: 400,
											text: 'Você deseja remover o(s) host(s) selecionado(s) da monitoração?',
											listeners: {
												beforerender: {
													fn: me.onLabelBeforeRender,
													scope: me
												}
											}
										},
										{
											xtype: 'label',
											flex: 1,
											margins: '5 0 0 0',
											cls: 'bold',
											padding: '10 0 0 0',
											shrinkWrap: 1,
											width: 400,
											text: 'O histórico do(s) elemento(s) será definitivamente perdido.',
											listeners: {
												beforerender: {
													fn: me.onLabelBeforeRender1,
													scope: me
												}
											}
										}
									]
								},
								{
									xtype: 'gridpanel',
									height: 252,
									width: 490,
									frameHeader: false,
									header: false,
									title: 'My Grid Panel',
									store: 'hostsSelectedInStatusgrid',
									columns: [
										{
											xtype: 'checkcolumn',
											width: 30,
											dataIndex: 'selected',
											text: ''
										},
										{
											xtype: 'gridcolumn',
											id: 'removeHostGridColumnHostName',
											width: 440,
											dataIndex: 'host_name',
											text: '{{Host}}'
										}
									],
									listeners: {
										boxready: {
											fn: me.onGridpanelBoxReady,
											scope: me
										}
									}
								},
								{
									xtype: 'toolbar',
									baseCls: 'x-toolbar-footer',
									height: 39,
									id: 'navBar13',
									items: [
										{
											xtype: 'tbspacer',
											flex: 3
										},
										{
											xtype: 'button',
											handler: function(button, event) {
												Ext.getCmp("delHostContainer").getLayout().setActiveItem(1);

												var elements = Ext.getStore("hostsSelectedInStatusgrid").data.items.reduce(
												function(acc, record) {
													return (record.get('selected'))
													? acc.concat(record.data.host_id)
													: acc;
												},
												[]
												);

												Ext.Ajax.request({

													url: '/opmon/seagull/www/index.php/discovery/action/del_hosts/',
													method: 'POST',
													timeout: 60000,
													params: {
														host_ids: JSON.stringify(elements)
													},
													success: function (result, request) {
														var obj;

														obj = JSON.parse(result.responseText);
														if (!obj) {
															Ext.getCmp("delHostContainer").getLayout().setActiveItem(0);
															showError(l["Unexpected error"], result.responseText);
															return;
														}

														if (obj.success === false) {
															Ext.getCmp("delHostContainer").getLayout().setActiveItem(0);
															showError(l["Unexpected error"], obj.message);
															return;
														}

														new Ext.util.LocalStorage({id: "items"}).setItem("items", Ext.getStore("hostsSelectedInStatusgrid").data.items.reduce(
														function(acc, record) {
															return (record.get('selected') === false)
															? acc.concat(record.get("host_id"))
															: acc;
														},
														[]
														));

														if (Wizard.endCallBack) {
															func = "parent."+Wizard.endCallBack+"(true);";
															eval(func);
														}

													},
													failure: function (result, request) {
														showError(l["Unexpected error"], l["Connection Error"]);
													}

												});



											},
											disabled: true,
											id: 'confirmRemoveHost',
											text: 'Sim, quero remover',
											listeners: {
												beforerender: {
													fn: me.onConfirmRemoveHostBeforeRender,
													scope: me
												}
											}
										},
										{
											xtype: 'tbspacer',
											flex: 1
										},
										{
											xtype: 'container',
											items: [
												{
													xtype: 'button',
													handler: function(button, event) {
														if (Wizard.endCallBack) {
															func = "parent."+Wizard.endCallBack+"(false);";
															eval(func);
														}
													},
													id: 'prevBtn13',
													width: 50,
													text: 'Não',
													listeners: {
														beforerender: {
															fn: me.onPrevBtn13BeforeRender,
															scope: me
														}
													}
												}
											]
										},
										{
											xtype: 'tbspacer',
											flex: 3
										}
									]
								}
							]
						},
						{
							xtype: 'container',
							minWidth: 250,
							padding: '',
							width: 250,
							layout: 'absolute',
							items: [
								{
									xtype: 'container',
									x: 40,
									y: 50,
									padding: 10,
									width: 40,
									items: [
										{
											xtype: 'image',
											height: 16,
											maxHeight: 16,
											maxWidth: 16,
											minHeight: 16,
											minWidth: 16,
											width: 16,
											src: '/opmon/oplib/libjs/extjs4/resources/opmon-darkblue/images/loadmask/loading.gif'
										}
									]
								},
								{
									xtype: 'label',
									x: 90,
									y: 60,
									height: 40,
									width: 160,
									text: 'Processing...',
									listeners: {
										beforerender: {
											fn: me.onLabelBeforeRender21,
											scope: me
										}
									}
								}
							]
						}
					]
				}
			]
		});

		me.callParent(arguments);
	},

	onLabelBeforeRender: function(component, eOpts) {
		var translatedtext = l["You want to remove the selected monitored host ( s ) ?"];
		component.text = translatedtext.replace("%NUMBER%", String(Wizard.urlData.hosts.length));
	},

	onLabelBeforeRender1: function(component, eOpts) {
		component.text = l["Element's history is going to be permanently removed"];
	},

	onGridpanelBoxReady: function(component, width, height, eOpts) {
		Ext.getCmp("removeHostGridColumnHostName").setText(l['Host']);
		var myMask = new Ext.LoadMask(component, {msg:l["Please wait"]});
		myMask.show();

		var hostsSelected = Wizard.urlData.hosts.map(function (id) {
			return {
				host_id: id
			};
		});

		Ext.getStore('Hosts').load().on('load', function prepareHosts(hosts) {
			hosts.un("load", prepareHosts);
			var selected = hostsSelected.filter(function (obj) {
				var host = hosts.findRecord('host_id', obj.host_id, 0, false, false, true);
				if (! host) {
					return false;
				}

				obj.host_name = host.get('host_name');
				obj.selected = true;
				return obj;
			});

			Ext.getStore('hostsSelectedInStatusgrid').add(selected);
			if (selected.length === 0) {
				component.getView().emptyText = l["The selected hosts are of the service catalog type and can not be removed."];
				component.getView().refresh();
			} else if (Wizard.urlData.hosts.length - selected.length !== 0) {
				var translatedtext = l["You want to remove the selected monitored hosts? Other hosts are of the service catalog type and can not be removed."];
				translatedtext = translatedtext.replace("%TOBEREMOVE%", String(selected.length));
				translatedtext = translatedtext.replace("%CANNOTBEREMOVE%", String(Wizard.urlData.hosts.length - selected.length));
				Ext.getCmp("messageRemoveHost").setText(translatedtext);
			}

			myMask.destroy();
			Ext.getCmp('confirmRemoveHost').setDisabled(false);
		});
	},

	onConfirmRemoveHostBeforeRender: function(component, eOpts) {
		component.text = l["Yes , I want to remove"];
	},

	onPrevBtn13BeforeRender: function(component, eOpts) {
		component.text = l["No"];
	},

	onLabelBeforeRender21: function(component, eOpts) {
		component.text = l["Wait"];
	}

});