/*
 * File: app/view/removeMenu.js
 *
 * This file was generated by Sencha Architect
 * http://www.sencha.com/products/architect/
 *
 * This file requires use of the Ext JS 4.2.x library, under independent license.
 * License of Sencha Architect does not include license for Ext JS 4.2.x. For more
 * details see http://www.sencha.com/license or contact license@sencha.com.
 *
 * This file will be auto-generated each and everytime you save your project.
 *
 * Do NOT hand edit this file.
 */

Ext.define('Wizard.view.removeMenu', {
	extend: 'Ext.menu.Menu',

	requires: [
		'Ext.menu.Item'
	],

	id: 'removeMenu',
	width: 120,

	initComponent: function() {
		var me = this;

		Ext.applyIf(me, {
			items: [
				{
					xtype: 'menuitem',
					handler: function(item, e) {
						var record;
						var treePanel;
						var params;
						var url;
						var hostStore;
						var hostgroupStore;
						var application;
						var i;
						var h;
						var j;
						var mymembers;
						var index;
						var newmembers;

						record = Wizard.selectedRecord;

						if (record.$className == "Wizard.model.HostGroup") {

							Ext.getCmp('hostGroupsTreePanel').disable();

							hostgroupStore = Wizard.getApplication().getHostGroupStoreStore();
							hostgroupTreeStore = Wizard.getApplication().getHostGroupTreeStoreStore();
							hostStore = Wizard.getApplication().getHostStoreStore();

							if (record.data.leaf === false) {

								hostgroupId = record.data.hostgroup_id;
								hostgroupStore = Wizard.getApplication().getHostGroupStoreStore();
								hostgroupStore.remove(record);
								hostgroupStore.sync();

								/* remove hostgroup from all hosts */
								for(i=0; i<hostStore.data.items.length; i++) {

									h = hostStore.data.items[i];

									mymembers = h.get("hostgroups");
									index = mymembers.indexOf(hostgroupId);
									if (index > -1) {
										mymembers.splice(index, 1);
									}
								}

								var root = hostgroupTreeStore.getRootNode();
								root.removeChild(record);

								Ext.getCmp('hostGroupsTreePanel').enable();

								return;
							}

							hostgroupId = record.parentNode.data.hostgroup_id;
							params = {
								host_name: record.data.hostgroup_name,
								hostgroup_name: record.parentNode.data.hostgroup_name
							};

							/* remove hostgroup from host store */
							h = getHostByName(params.host_name);
							if (h !== null) {
								mymembers = h.get("hostgroups");
								index = mymembers.indexOf(hostgroupId);
								if (index > -1) {
									mymembers.splice(index, 1);
								}
							}

							/* remove host from hostgroup */
							var precord = record.parentNode;
							precord.removeChild(record);

							Ext.Ajax.request({
								url: "/opmon/seagull/www/index.php/discovery/action/hostgroups/operation/removehostfromhostgroup/",
								method: 'POST',
								params: params,
								success: function(result, request) {
									var obj;

									obj = JSON.parse(result.responseText);
									if (!obj) {
										showError("Unexpected error", "Unable parse", result.responseText);
										return;
									}

									if (!obj.success) {
										showError("Unexpected error",obj.message, obj);
										return;
									}

									Ext.getCmp('hostGroupsTreePanel').enable();

								},
								failure: function(result, request) {
									showError("Unexpected error","Unable to reach server",result);
								}
							});

							return;

						} else if (record.$className == "Wizard.model.ContactGroup") {

							Ext.getCmp('teamsTreePanel').disable();

							contactgroupStore = Wizard.getApplication().getContactGroupStoreStore();
							contactTreeStore = Wizard.getApplication().getContactGroupTreeStoreStore();
							hostsStore = Wizard.getApplication().getHostStoreStore();
							contactsStore = Wizard.getApplication().getContactStoreStore();

							if (record.data.leaf === false) { /* a complete contactgroup */

								contactgroupId = record.data.contactgroup_id;
								contactgroupStore.remove(record);
								contactgroupStore.sync();

								/* remove contact group of all hosts */
								for(i=0; i<hostsStore.getCount(); i++) {

									h = hostsStore.getAt(i);

									mymembers = h.get("contactgroups");
									index = mymembers.indexOf(contactgroupId);
									if (index > -1) {
										mymembers.splice(index, 1);
									}
									h.set("contactgroups",mymembers);
								}

								contactTreeStore.getRootNode().removeChild(record);

								store = Wizard.getApplication().getContactTreeStoreStore();
								store.getRootNode().removeAll();
								store.load();

								Ext.getCmp('teamsTreePanel').enable();
								return;
							}

							contactgroupId = record.parentNode.data.contactgroup_id;
							params = {
								contact_name: record.data.contactgroup_name,
								contactgroup_name: record.parentNode.data.contactgroup_name
							};

							idx = indexOfObject(record.parentNode.data.members, "contactgroup_id", record.raw.contactgroup_id);
							if (idx >= 0) {
								m = record.parentNode.get("members");
								m.splice(idx,1);
								record.parentNode.set("members",m);
							}

							record.parentNode.removeChild(record);

							Ext.Ajax.request({
								url: "/opmon/seagull/www/index.php/discovery/action/contactgroups/operation/removecontactfromcontactgroup/",
								method: 'POST',
								params: params,
								success: function(result, request) {
									var obj;

									obj = JSON.parse(result.responseText);
									if (!obj) {
										showError("Unexpected error", "Unable parse", result.responseText);
										return;
									}

									if (!obj.success) {
										showError("Unexpected error",obj.message, obj);
										return;
									}

									Ext.getCmp('teamsTreePanel').enable();

									store = Wizard.getApplication().getContactTreeStoreStore();
									store.getRootNode().removeAll();
									store.load();
								},
								failure: function(result, request) {
									showError("Unexpected error","Unable to reach server",result);
								}
							});

							return;

						} else if (record.$className == "Wizard.model.Contact") {


							contactgroupStore = Wizard.getApplication().getContactGroupStoreStore();
							contactTreeStore = Wizard.getApplication().getContactGroupTreeStoreStore();
							hostsStore = Wizard.getApplication().getHostStoreStore();
							contactsStore = Wizard.getApplication().getContactStoreStore();
							Ext.getCmp('teamsTreePanel').disable();
							Ext.getCmp('contactsTreePanel').disable();

							if (record.data.leaf === false) {

								/* remove a contact and reload */
								contact = getContactByName(record.data.contact_name);
								if (contact === null || contact.get("contact_name") == "opmonadmin") {
									showError("Permission denied","You can not remove opmonadmin user");
									Ext.getCmp('teamsTreePanel').enable();
									Ext.getCmp('contactsTreePanel').enable();
									return;
								}

								afterSync = {
									callback: function(records, operation, success) {
										store = Wizard.getApplication().getContactGroupTreeStoreStore();
										store.getRootNode().removeAll();
										store.load();
										store = Wizard.getApplication().getContactTreeStoreStore();
										store.getRootNode().removeAll();
										store.load();
										Ext.getCmp('teamsTreePanel').enable();
										Ext.getCmp('contactsTreePanel').enable();
									}
								};

								contactsStore.remove(contact);
								contactsStore.sync(afterSync);
								return;
							}

							contactName = record.parentNode.data.contact_name;
							params = {
								contact_name: contactName,
								contactgroup_name: record.data.contact_name
							};


							idx = indexOfObject(record.parentNode.data.contactgroups, "contact_name", contactName);
							if (idx >= 0) {
								m = record.parentNode.get("contactgroups");
								m.splice(idx,1);
								record.parentNode.set("contactgroups",m);
							}

							Ext.Ajax.request({
								url: "/opmon/seagull/www/index.php/discovery/action/contacts/operation/removecontactgroupfromcontact/",
								method: 'POST',
								params: params,
								success: function(result, request) {
									var obj;

									obj = JSON.parse(result.responseText);
									if (!obj) {
										showError("Unexpected error", "Unable parse", result.responseText);
										return;
									}

									if (!obj.success) {
										showError("Unexpected error",obj.message, obj);
										return;
									}

									store = Wizard.getApplication().getContactGroupTreeStoreStore();
									store.getRootNode().removeAll();
									store.load();
									store = Wizard.getApplication().getContactTreeStoreStore();
									store.getRootNode().removeAll();
									store.load();
									Ext.getCmp('teamsTreePanel').enable();
									Ext.getCmp('contactsTreePanel').enable();
								},
								failure: function(result, request) {
									showError("Unexpected error","Unable to reach server",result);
								}
							});

							return;

						}


						/* record.$className == "Wizard.model.ServiceGroup" */
						Ext.getCmp('serviceGroupsTreePanel').disable();

						servicegroupStore = Wizard.getApplication().getServiceGroupStoreStore();
						servicegroupTreeStore = Wizard.getApplication().getServiceGroupTreeStoreStore();
						serviceStore = Wizard.getApplication().getServiceStoreStore();

						if (record.data.leaf === false) {

							servicegroupId = record.data.servicegroup_id;
							servicegroupStore.remove(record);
							servicegroupStore.sync();

							/* remove hostgroup from all hosts */
							for(i=0; i<serviceStore.data.items.length; i++) {

								h = serviceStore.data.items[i];
								mymembers = h.get("servicegroups");
								index = mymembers.indexOf(servicegroupId);
								if (index > -1) {
									mymembers.splice(index, 1);
								}
							}

							var root = servicegroupTreeStore.getRootNode();
							root.removeChild(record);

							Ext.getCmp('serviceGroupsTreePanel').enable();
							return;

						}

						host = getMonitoredHostById(record.raw.host_id);
						if (host == null) {
							console.log("unable to locate host");
							return;
						}

						params = {
							service_description: record.raw.service_description,
							servicegroup_name: record.parentNode.raw.servicegroup_name,
							host_name: host.get("host_name")
						};

						servicegroup = getServiceGroupByName(params.servicegroup_name);
						if (servicegroup === null) {
							console.log("unable to locat servicegroup");
							return;
						}

						servicegroupId = servicegroup.get("servicegroup_id");

						/* remove servicegroup from service store */
						h = getMonitoredServiceByName(params.host_name, params.service_description);
						if (h !== null) {
							mymembers = h.get("servicegroups");
							index = mymembers.indexOf(servicegroupId);
							if (index > -1) {
								mymembers.splice(index, 1);
							}
						}

						/* remove service from servicegroup */
						var precord = record.parentNode;
						precord.removeChild(record);

						Ext.Ajax.request({

							url: "/opmon/seagull/www/index.php/discovery/action/servicegroups/operation/removeservicefromservicegroup/",
							method: 'POST',
							params: params,
							success: function(result, request) {
								var obj;

								obj = JSON.parse(result.responseText);
								if (!obj) {
									showError("Unexpected error", "Unable to parse", result.responseText);
									return;
								}

								if (!obj.success) {
									showError("Unexpected error", obj.message);
									return;
								}

								Ext.getCmp('serviceGroupsTreePanel').enable();

							},
							failure: function(result, request) {
								showError("Unexpected error", "Unable to reach server", result.responseText);
							}
						});

					},
					text: 'Remove',
					listeners: {
						beforerender: {
							fn: me.onMenuitemBeforeRender,
							scope: me
						}
					}
				}
			]
		});

		me.callParent(arguments);
	},

	onMenuitemBeforeRender: function(component, eOpts) {
		component.text = l["Remove"];
	}

});