/*
 * File: app/view/removeService.js
 *
 * This file was generated by Sencha Architect
 * http://www.sencha.com/products/architect/
 *
 * This file requires use of the Ext JS 4.2.x library, under independent license.
 * License of Sencha Architect does not include license for Ext JS 4.2.x. For more
 * details see http://www.sencha.com/license or contact license@sencha.com.
 *
 * This file will be auto-generated each and everytime you save your project.
 *
 * Do NOT hand edit this file.
 */

Ext.define('Wizard.view.removeService', {
	extend: 'Ext.window.Window',

	requires: [
		'Ext.form.Label',
		'Ext.grid.Panel',
		'Ext.grid.column.CheckColumn',
		'Ext.grid.View',
		'Ext.toolbar.Toolbar',
		'Ext.toolbar.Spacer',
		'Ext.button.Button',
		'Ext.Img',
		'Ext.toolbar.Fill'
	],

	draggable: false,
	height: 400,
	id: 'removeHost1',
	width: 610,
	header: false,
	title: 'Remover o(s) host(s)?',
	modal: true,

	initComponent: function() {
		var me = this;

		Ext.applyIf(me, {
			listeners: {
				beforerender: {
					fn: me.onRemoveHost1BeforeRender,
					scope: me
				}
			},
			items: [
				{
					xtype: 'container',
					height: 390,
					id: 'delServiceContainer',
					minWidth: 250,
					width: 600,
					layout: 'card',
					items: [
						{
							xtype: 'container',
							width: 600,
							items: [
								{
									xtype: 'container',
									height: 100,
									id: 'serviceParamsPanel3',
									width: 600,
									layout: {
										type: 'vbox',
										align: 'center',
										pack: 'center',
										padding: 20
									},
									items: [
										{
											xtype: 'label',
											flex: 1,
											height: 20,
											id: 'messageRemoveService',
											maxHeight: 400,
											shrinkWrap: 1,
											width: 500,
											text: 'Você deseja remover o(s) servico(s) selecionado(s) da monitoração?',
											listeners: {
												beforerender: {
													fn: me.onMessageRemoveServiceBeforeRender,
													scope: me
												}
											}
										},
										{
											xtype: 'label',
											flex: 1,
											margins: '5 0 0 0',
											cls: 'bold',
											padding: '10 0 0 0',
											width: 500,
											text: 'O histórico do(s) elemento(s) será definitivamente perdido.',
											listeners: {
												beforerender: {
													fn: me.onLabelBeforeRender1,
													scope: me
												}
											}
										}
									]
								},
								{
									xtype: 'gridpanel',
									height: 240,
									id: 'removeServiceGrid',
									width: 600,
									autoScroll: true,
									frameHeader: false,
									header: false,
									title: 'My Grid Panel',
									store: 'servicesSelectedInStatusgrid',
									columns: [
										{
											xtype: 'checkcolumn',
											width: 30,
											dataIndex: 'selected'
										},
										{
											xtype: 'gridcolumn',
											id: 'removeServiceGridColumnHostName',
											maxWidth: 200,
											width: 200,
											dataIndex: 'host_name',
											text: '{{Host}}'
										},
										{
											xtype: 'gridcolumn',
											id: 'removeServiceGridColumnServiceDescription',
											maxWidth: 350,
											width: 350,
											dataIndex: 'service_description',
											text: '{{Service}}'
										}
									],
									viewConfig: {
										id: 'removeServiceGridView'
									},
									listeners: {
										boxready: {
											fn: me.onGridpanelBoxReady,
											scope: me
										}
									}
								},
								{
									xtype: 'toolbar',
									baseCls: 'x-toolbar-footer',
									height: 50,
									id: 'navBar15',
									width: 600,
									items: [
										{
											xtype: 'tbspacer',
											flex: 3
										},
										{
											xtype: 'button',
											handler: function(button, event) {
												Ext.getCmp("delServiceContainer").getLayout().setActiveItem(1);

												var elements = Ext.getStore("servicesSelectedInStatusgrid").data.items.reduce(
												function(acc, record) {
													return (record.get('selected'))
													? acc.concat(record.data)
													: acc;
												},
												[]
												);

												Ext.Ajax.request({

													url: '/opmon/seagull/www/index.php/discovery/action/del_services/',
													method: 'POST',
													timeout: 60000,
													params: {
														services: JSON.stringify(elements)
													},
													success: function (result, request) {
														var obj;

														obj = JSON.parse(result.responseText);
														if (!obj) {
															Ext.getCmp("delServiceContainer").getLayout().setActiveItem(0);
															showError(l["Unexpected error"], result.responseText);
															return;
														}

														if (obj.success === false) {
															Ext.getCmp("delServiceContainer").getLayout().setActiveItem(0);
															showError(l["Unexpected error"], obj.message);
															return;
														}


														if (obj.services_not_deleted === true) {
															Ext.getCmp("delServiceContainer").getLayout().setActiveItem(2);
															return;
														}

														new Ext.util.LocalStorage({id: "items"}).setItem("items", Ext.getStore("servicesSelectedInStatusgrid").data.items.reduce(
														function(acc, record) {
															return (record.get('selected') === false)
															? acc.concat(record.get("host_id")+"!"+record.get("service_id"))
															: acc;
														},
														[]
														));

														if (Wizard.endCallBack) {
															func = "parent."+Wizard.endCallBack+"(true);";
															eval(func);
														}

													},
													failure: function (result, request) {
														showError(l["Unexpected error"], l["Connection Error"]);
													}

												});
											},
											disabled: true,
											id: 'confirmRemoveService',
											text: 'Sim, quero remover',
											listeners: {
												beforerender: {
													fn: me.onConfirmRemoveServiceBeforeRender,
													scope: me
												}
											}
										},
										{
											xtype: 'tbspacer',
											flex: 1
										},
										{
											xtype: 'container',
											items: [
												{
													xtype: 'button',
													handler: function(button, event) {
														if (Wizard.endCallBack) {
															func = "parent."+Wizard.endCallBack+"(false);";
															eval(func);
														}
													},
													id: 'prevBtn14',
													width: 50,
													text: 'Não',
													listeners: {
														beforerender: {
															fn: me.onPrevBtn14BeforeRender,
															scope: me
														}
													}
												}
											]
										},
										{
											xtype: 'tbspacer',
											flex: 3
										}
									]
								}
							]
						},
						{
							xtype: 'container',
							minWidth: 250,
							padding: '',
							width: 250,
							layout: 'absolute',
							items: [
								{
									xtype: 'container',
									x: 40,
									y: 50,
									padding: 10,
									width: 40,
									items: [
										{
											xtype: 'image',
											height: 16,
											maxHeight: 16,
											maxWidth: 16,
											minHeight: 16,
											minWidth: 16,
											width: 16,
											src: '/opmon/oplib/libjs/extjs4/resources/opmon-darkblue/images/loadmask/loading.gif'
										}
									]
								},
								{
									xtype: 'label',
									x: 90,
									y: 60,
									height: 40,
									width: 160,
									text: 'Processing...',
									listeners: {
										beforerender: {
											fn: me.onLabelBeforeRender2,
											scope: me
										}
									}
								}
							]
						},
						{
							xtype: 'container',
							items: [
								{
									xtype: 'container',
									minHeight: 120,
									layout: 'absolute',
									items: [
										{
											xtype: 'label',
											x: 20,
											y: 30,
											maxWidth: 200,
											text: 'Alguns serviços selecionados pertecem a um template e não podem ser removidos',
											listeners: {
												beforerender: {
													fn: me.onLabelBeforeRender3,
													scope: me
												}
											}
										}
									]
								},
								{
									xtype: 'toolbar',
									baseCls: 'x-toolbar-footer',
									maxWidth: 240,
									items: [
										{
											xtype: 'tbfill'
										},
										{
											xtype: 'container',
											items: [
												{
													xtype: 'button',
													handler: function(button, e) {
														if (Wizard.endCallBack) {
															func = "parent."+Wizard.endCallBack+"(false);";
															eval(func);
														}
													},
													text: 'OK'
												}
											]
										}
									]
								}
							]
						}
					]
				}
			]
		});

		me.callParent(arguments);
	},

	onRemoveHost1BeforeRender: function(component, eOpts) {
		component.title = l["Remove service (s) ?"];
	},

	onMessageRemoveServiceBeforeRender: function(component, eOpts) {
		var translatedtext = l["You want to remove the selected monitored service ( s ) ?"];
		component.text = translatedtext.replace("%NUMBER%", String(Wizard.urlData.services.length));
	},

	onLabelBeforeRender1: function(component, eOpts) {
		component.text = l["Element's history is going to be permanently removed"];
	},

	onGridpanelBoxReady: function(component, width, height, eOpts) {
		Ext.getCmp("removeServiceGridColumnHostName").setText(l['Host']);
		Ext.getCmp("removeServiceGridColumnServiceDescription").setText(l['Service']);
		var myMask = new Ext.LoadMask(component, {msg:l["Please wait"]});
		myMask.show();

		Ext.getStore('Hosts').load().on('load', function prepareHosts(hosts) {
			hosts.un("load", prepareHosts);
			Ext.getStore('alreadyMonitoredServiceStore').load().on('load', function prepareServices(services) {
				services.un("load", prepareServices);
				var selected = Wizard.urlData.services.filter(function (obj) {
					var host = hosts.findRecord('host_id', obj.host_id, 0, false, false, true);
					var service = services.findRecord('service_id', obj.service_id, 0, false, false, true);

					if (! host || ! service) {
						return false;
					}
					obj.host_name = host.get('host_name');
					obj.service_description = service.get('service_description');
					obj.selected = true;
					return obj;
				});

				Ext.getStore('servicesSelectedInStatusgrid').add(selected);
				if (selected.length === 0) {
					component.getView().emptyText = l["Some of your services belong to a template, unable to remove them"];
					component.getView().refresh();
				} else if (Wizard.urlData.services.length - selected.length !== 0) {
					var translatedtext = l["You want to remove the selected monitored services? Other services belong to a template and can not be removed."];
					translatedtext = translatedtext.replace("%TOBEREMOVE%", String(selected.length));
					translatedtext = translatedtext.replace("%CANNOTBEREMOVE%", String(Wizard.urlData.services.length - selected.length));
					Ext.getCmp("messageRemoveService").setText(translatedtext);
				}

				myMask.destroy();
				Ext.getCmp('confirmRemoveService').setDisabled(false);
			});


		});
	},

	onConfirmRemoveServiceBeforeRender: function(component, eOpts) {
		component.text = l["Yes , I want to remove"];
	},

	onPrevBtn14BeforeRender: function(component, eOpts) {
		component.text = l["No"];
	},

	onLabelBeforeRender2: function(component, eOpts) {
		component.text = l["Wait"];
	},

	onLabelBeforeRender3: function(component, eOpts) {
		component.text = l["Some of your services belong to a template, unable to remove them"];
	}

});